
module.exports = function (runtime, scope) {
    var ws = runtime.websocketBridge;
    var websocketBridge = Object.create(ws);
    var websocket = {};

    websocket.sendMessage = function (msg) {
        msg = msg || '';
        if(typeof(msg) === 'string') {
            return websocketBridge.sendMessage(msg);
        }
        return websocketBridge.sendMessage(JSON.stringify(msg));
    }

    global.__asGlobal__(websocket, ['sendMessage']);

    return websocket;
}