/**
 * 西班牙语录制
 */
var common = require("./common");
// var floaty_all = require("./floaty_all");
var request = require("./request");
var storage = storages.create('Hodgepodge');
var storageAJ = storages.create("AJ动作录制");
var show_ary = ["id", "text", "desc", "clickable", "className", "bounds","visibleToUser", "scrollable", "depth","getChildCount","getActionList","hashCode","getWindow","indexInParent"];
var lz_mode = 'fast';
var now_mode = (lz_mode=='fast')?"Simple":"Precisión";
var currentAppName;
var currentPkg = currentPackage();
var pm = context.getPackageManager();
var appList=pm.getInstalledApplications(0);
var appInfoList=[];
var nowPkg = null;
var fileType = 1;
var floaty_w = 150;
//  var lzdir = context.getFilesDir()+"/douzhu/";
var lzdir = "/sdcard/douzhu/";
home();
var floaty_all = {
    win:floaty.rawWindow(
        <frame grivaty="center" alpha="1" w="*" h="*">
            <img id="img" w="*" h="*" />
        </frame>
    ),

    /**
     * 
     */
    win_:floaty.rawWindow(
        <vertical>

            <button id="but_y" text="Mover" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
            <button visibility="gone" id="but_e" text="Zoom" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
            <button visibility="gone" id="but_h" text="Introducir texto manualmente" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
            <button visibility="gone" id="but_hh" text="Selección de plantillas" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />

            <vertical layout_weight="7" id="left_main">
                <button visibility="gone" id="but_q" text="Limpieza" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
                <button visibility="gone" id="but_c" text="Revocación" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
                <button visibility="gone" id="but_lq" text="录制昙花场景" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
                <button id="but_l" text="Grabar una escena normal" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
                <button id="but_p"  text="Ejecutar grabación" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
                <button id="but_s" visibility="gone" text="生成代码" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
                <button id="but_b" text="Complete" w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
            </vertical>

        </vertical>
    ),
    word_:floaty.rawWindow(
        <vertical id="word_" visibility="gone">
            <scroll h="390">
                <list id="word_list">

                    <vertical>
                        <button ellipsize="end" id="word_y" text="{{this.name}}" w="150" h="35" bg="#FFFFFF" textSize="13sp" />
                    </vertical>

                </list>
            </scroll>
        </vertical>
        
    ),
    

    expor:floaty.rawWindow(
        <button id="but_g" text=" close " w={floaty_w} h="35" bg="#77ffffff" textSize="13sp" />
    )
}
for(let i=0;i<appList.size();i++){
    let app=appList.get(i);
    let appInfo={
        appName:app.loadLabel(pm),
        packageName:app.packageName,
    }
    appInfoList.push(appInfo);
}

appInfoList.sort((a,b)=>{
    return b.firstInstallTime-a.firstInstallTime;
});

var appNames = [];
var appPkgs = [];
let appInfo = [];
appInfoList.forEach(function(item,index){
    appNames.push(item.appName);
    appPkgs.push(item.packageName);
    appInfo[item.packageName] = item.appName;
});



var timestamp;//时间戳计时
var win = floaty_all.win;


win.setSize(device.width, device.height);
win.setTouchable(false);

var win_ = floaty_all.win_;
var expor = floaty_all.expor; //关闭按钮
var word_ = floaty_all.word_;

word_.setPosition(win_.getX()+win_.width,win_.getY()+66);

var af = new 绘布(win.img);
var ad = new 悬浮控制(win, null, true);
var ad_ = new 悬浮控制(win_, win_.but_y, true);

// ad_.setLongClick(exit);

var F = ad.OutScreen();
var F_ = ad_.OutScreen();


expor.setPosition(win_.getX(),win_.getY()+win_.height + 66);


var paint = new Paint;
//paint.setTextAlign(Paint.Align.CENTER);
paint.setStrokeWidth(5);
paint.setStyle(Paint.Style.STROKE);
paint.setARGB(255, 255, 0, 0);
var textSize = 50;
paint.setTextSize(textSize);


//每次动作。
var MainGesturesAry = new Array; //↓↓↓↓
var MainResAry = new Array; //↓↓↓↓
var MainClAry = new Array; //↓↓↓↓
var MainDsqAry = new Array; //↓↓↓↓
var ActionName = new Array; //↓↓↓↓
var ChanceArr = new Array;
var WordArr = new Array; //话术
var ChanceLimitArr = new Array; //概率修改限制

var ActionName_test = new Array; //↓↓↓↓
//一次中的手指动作。
var gesturesAry = new Array; //手势集合↓↓↓↓[[0,100,[x1,y1],[x2,y2],[x3,y3],[x4,y4],………],………]
var resAry = new Array; //节点集合
var clAry = new Array(); //点击坐标集合
var dsqAry = new Array(); //间隔时间 集合
//每个手指的动作。
var TouchPointRecord = new Array; //[[0,1000,[x1,y1],………],………]

var TouchPointStart = new Array; //[[x1,y1],[x2,y2],[x3,y3],[x4,y4],………]
var TouchPointCurrent = new Array; //[[x1,y1],[x2,y2],[x3,y3],[x4,y4],………]

var vrx = 0,
    vry = 0; //屏幕坐标差。

threads.start(function () {
    //console.show();
    sleep(500);
    af.isOK();
    af.Refresh(reDraw);
});

var Ts = 50; //动作精度。越小精度越高。//但实际上没卵用。自动操作函数gestures会自动缩减
var Tss = 400; //动作间隔
var kg = false;
var jishi = 0;
//new android.graphics.RectF

setInterval(() => {
    if (kg) {
        jishi++;
        for (let i = 0; i < TouchPointRecord.length; i++) {
            try {
                let x = Math.floor(TouchPointCurrent[i][0] + vrx);
                let y = Math.floor(TouchPointCurrent[i][1] + vry);
                TouchPointRecord[i].push([x, y]);
                TouchPointRecord[i][1] += Ts;
            } catch (e) {
                break;
            };
        };
    };
}, Ts);

function 绘布(view) {
    if (view.accessibilityClassName != "android.widget.ImageView") {
        //throw "我报错";
    };
    this.width = view.getWidth();
    this.height = view.getHeight();
    this.bitmap = android.graphics.Bitmap.createBitmap(this.width || 1000, this.height || 1000, android.graphics.Bitmap.Config.ARGB_8888);
    this.canvas = new Canvas(this.bitmap);
    this.matrix = new android.graphics.Matrix();
    //threads.start(new java.lang.Runnable(() => {}));
    this.isOK = () => {
        this.width = view.getWidth();
        this.height = view.getHeight();
        this.bitmap = android.graphics.Bitmap.createBitmap(this.width || 1000, this.height || 1000, android.graphics.Bitmap.Config.ARGB_8888);
        this.canvas = new Canvas(this.bitmap);
        if (this.width <= 0 || this.height <= 0) {
            return false;
        };
        return true;
    };

    this.Draw = function () { };
    this.setDraw = function (fun) {
        if (typeof fun == "function") {
            this.Draw = fun;
        };
    };

    this.Refresh = (fun) => {
        try {
            this.bitmap.eraseColor(0);
            this.canvas.setMatrix(this.matrix);
            if (typeof fun == "function") {
                fun(this.canvas);
            } else {
                this.Draw(this.canvas);
            };
            ui.run(() => {
                view.setImageBitmap(this.bitmap);
            });
        } catch (e) {
            toastLog(getError(e));
        };
    };


};



function 悬浮控制(window, windowid, ar) {
    this.Orientation = context.resources.configuration.orientation;
    this.Width = this.Orientation == 1 ? device.width : device.height;
    this.Height = this.Orientation == 2 ? device.width : device.height;
    this.isAutoIntScreen = true;
    this.Click = function () { };
    this.Move = function () { };
    this.LongClick = function () { };
    this.setClick = (fun) => {
        fun = fun || function () { };
        this.Click = fun;
    };
    this.setMove = (fun) => {
        fun = fun || function () { };
        this.Move = fun;
    };
    this.setPosition = function(xy_arr){
        window.setPosition(xy_arr[0],xy_arr[1]);
    }
    this.setLongClick = (fun, ji) => {
        fun = fun || function () { };
        this.LongClick = fun;
        if (parseInt(ji)) {
            this.Tjitime = parseInt(ji) / 50;
        };
    };
    setInterval(() => {
        if (context.resources.configuration.orientation != this.Orientation) {
            this.Orientation = context.resources.configuration.orientation;
            this.Width = this.Orientation == 1 ? device.width : device.height;
            this.Height = this.Orientation == 2 ? device.width : device.height;
            let xy = this.windowGXY(window.getX(), window.getY(), this.G(window));
            this.windowyidong([
                [window.getX(), window.getY()],
                [xy.x, xy.y]
            ]);
        };
    }, 100);
    this.TX = 0;
    this.TY = 0;
    this.Tx = 0;
    this.Ty = 0;
    this.Tyidong = false;
    this.Tkeep = false;
    this.Tjitime = 12;
    this.Ttime = 0;
    setInterval(() => {
        if (this.Tkeep) {
            this.Ttime++;
            if (!this.Tyidong && this.Ttime > this.Tjitime) {
                //非移动且按下时长超过1秒判断为长按
                this.Tkeep = false;
                this.Ttime = 0;
                this.LongClick();
            };
        };
    }, 50);
    if (windowid) {
        windowid.setOnTouchListener(new android.view.View.OnTouchListener((view, event) => {
            this.Move(view, event);
            switch (event.getAction()) {
                case event.ACTION_DOWN:
                    this.Tx = event.getRawX();
                    this.Ty = event.getRawY();
                    this.TX = window.getX();
                    this.TY = window.getY();
                    this.Tkeep = true; //按下,开启计时
                    break;
                case event.ACTION_MOVE:

                    let sx = event.getRawX() - this.Tx;
                    let sy = event.getRawY() - this.Ty;
                    if (!this.Tyidong && this.Tkeep && this.weiyi(sx, sy) >= 10) {
                        this.Tyidong = true;
                    };
                    if (this.Tyidong && this.Tkeep) {
                        window.setPosition(this.TX + sx, this.TY + sy);
                        expor.setPosition(win_.getX(),win_.getY()+win_.height);
                        word_.setPosition(win_.getX()+win_.width,win_.getY());
                    };
                    break;
                case event.ACTION_UP:
                    if (!this.Tyidong && this.Tkeep && this.Ttime < 7) {
                        this.Click();
                    };
                    this.Tkeep = false;
                    this.Ttime = 0;
                    if (this.Tyidong) {
                        if (this.isAutoIntScreen) {
                            threads.start(new java.lang.Runnable(() => {
                                this.windowyidong(this.IntScreen());
                            }));
                        } else {
                            threads.start(new java.lang.Runnable(() => {
                                this.windowyidong(this.ViewIntScreen());
                            }));

                        };

                        this.Tyidong = false;
                    };
                    break;
            };
            return true;
        }));
    };
    this.G = (win, view) => {
        //返回悬浮窗的坐标范围。
        let K = 36, //悬浮窗的隐形边矩
            H = 66; //手机通知栏的高度
        let ary;
        if (!ar) {
            if (view) {
                ary = [
                    [-view.getX(), -view.getY()],
                    [this.Width - (view.getX() + view.getWidth()), this.Height - (view.getY() + view.getHeight()) - H - K]
                ];

            } else {
                ary = [
                    [0, 0],
                    [this.Width - win.getWidth() + K * 2, this.Height - win.getHeight() - H + K * 2]
                ];
            }
        } else {
            if (view) {
                ary = [
                    [-view.getX(), H - view.getY()],
                    [this.Width - (view.getX() + view.getWidth()), this.Height - (view.getY() + view.getHeight())]
                ];

            } else {
                ary = [
                    [0, H],
                    [this.Width - win.getWidth(), this.Height - win.getHeight()]
                ];
            }
        };
        return ary;
    };
    this.weiyi = function () { //平方和开方
        let num = 0;
        for (let i = 0; i < arguments.length; i++) {
            num += arguments[i] * arguments[i];
        };
        return Math.round(Math.sqrt(num) * 1000) / 1000
    };
    this.windowGXY = function (x, y, k) {
        //修正坐标的所在范围。如果坐标超出了范围，则修正回来。
        x = (k[0][0] < x && x < k[1][0]) ? x : (k[0][0] < x ? k[1][0] : k[0][0]);
        y = (k[0][1] < y && y < k[1][1]) ? y : (k[0][1] < y ? k[1][1] : k[0][1]);
        return {
            x: x,
            y: y
        };
    };
    this.windowyidong = (A, s, w) => {
        //移动悬浮窗的动画效果。
        w = w || window;
        s = s || 10;
        let sx = A[1][0] - A[0][0],
            sy = A[1][1] - A[0][1];
        let sd = this.weiyi(sx, sy) / s;
        let X = sx / sd,
            Y = sy / sd;
        let x = 0,
            y = 0;
        for (let i = 0; i < sd; i++) {
            x += X;
            y += Y;
            sleep(1);
            w.setPosition(A[0][0] + x, A[0][1] + y);
            expor.setPosition(win_.getX()+ x,win_.getY()+win_.height+ y);
            word_.setPosition(win_.getX()+win_.width,win_.getY()+y);
        };
        w.setPosition(A[1][0], A[1][1]);
        expor.setPosition(A[1][0],A[1][1]+win_.height);
        word_.setPosition(A[1][0]+win_.width,A[1][1]);
    };
    this.OutScreen = () => {
        //算出最短的距离到达屏幕之外。
        let F = this.G(window);
        let x = window.getX(),
            y = window.getY();
        let sx = window.getX() + window.getWidth() / 2,
            sy = window.getY() + window.getHeight() / 2 + 66;
        let cx = Math.abs(sx < (this.Width - sx) ? sx : (this.Width - sx)) < Math.abs(sy < (this.Height - sy) ? sy : (this.Height - sy)) ? (sx < this.Width / 2 ? (F[0][0] - window.getWidth()) : (F[1][0] + window.getWidth())) : x,
            cy = Math.abs(sx < (this.Width - sx) ? sx : (this.Width - sx)) < Math.abs(sy < (this.Height - sy) ? sy : (this.Height - sy)) ? y : (sy < this.Height / 2 ? (F[0][1] - window.getHeight()) : (F[1][1] + window.getHeight()));
        return [
            [x, y],
            [cx, cy]
        ];
    };
    this.toScreenEdge = (d) => {
        //返回到屏幕边缘的坐标。d为浮点数0.1~1之间。
        d = d || 0;
        let F = this.G(window);
        let x = window.getX(),
            y = window.getY();
        let sw = window.getWidth() * d;
        let sx = window.getX() + window.getWidth() / 2,
            sy = window.getY() + window.getHeight() / 2 + 66;
        let cx = sx < (this.Width - sx) ? -sw : (this.Width + sw - window.getWidth() + 72);
        return [
            [x, y],
            [cx, y]
        ];
    };
    this.centerXY = (F) => {
        //返回距离中心位置的一个方形两个坐标。
        let w = window.getWidth();
        let h = window.getHeight();
        return [
            [F[0] + w / 2, F[1] + h / 2],
            [F[0] - w / 2, F[1] - h / 2]
        ];
    };
    this.IntScreen = () => {
        //当悬浮超出屏幕之外之后进入的坐标。
        let A = this.windowGXY(window.getX(), window.getY(), this.G(window));
        return [
            [window.getX(), window.getY()],
            [A.x, A.y]
        ];
    };
    this.ViewIntScreen = () => {
        //当悬浮超出屏幕之外之后进入的坐标。
        let A = this.windowGXY(window.getX(), window.getY(), this.G(window, windowid));
        return [
            [window.getX(), window.getY()],
            [A.x, A.y]
        ];
    };
    threads.start(new java.lang.Runnable(() => {
        this.windowyidong(this.IntScreen());
    }));
};

win_.but_q.click(function () {
    //重指
    for (let ii = 0; ii < TouchPointRecord.length; ii++) {
        let x = Math.floor(TouchPointCurrent[ii][0] + vrx);
        let y = Math.floor(TouchPointCurrent[ii][1] + vry);
        gesturesAry.push(TouchPointRecord[ii]);
        TouchPointRecord[ii] = [jishi * Ts, 0, [x, y]]
    };


    MainGesturesAry = new Array;
    MainResAry = new Array;
    MainClAry = new Array;
    MainDsqAry = new Array;
    ActionName = new Array;
    ChanceArr = new Array;
    ChanceLimitArr = new Array;
    WordArr = new Array;
    beforeArr = new Array;

    ActionName_test = new Array;

    af.Refresh(reDraw);
    toastLog("Acción de vaciado");
});

win_.but_c.click(function () {
    MainGesturesAry.pop();
    MainResAry.pop();
    MainClAry.pop();
    MainDsqAry.pop();
    ActionName.pop();
    ChanceArr.pop();
    ChanceLimitArr.pop();
    WordArr.pop();

    ActionName_test.pop();

    af.Refresh(reDraw);
    toastLog("Compete");
});

win_.but_l.click(function (v) {
    fileType = 1;

    if (v.getText() == "Grabación") {
        let d = dialogs.build({
            title: "Cierre de la grabación...",
            progress: {
                max: -1
            },
            cancelable: false
        }).show();

        setTimeout(() => {
            win_.but_l.attr("bg", "#77ffffff");
            v.setText("Grabar una escena normal");
            win.setTouchable(false);
            d.dismiss();
        }, 1000);

    } else {

        try{
            currentPkg = currentPackage();
            currentAppName = getAppName(currentPackage());
        }catch(e){
            currentPkg = '';
            currentAppName = '';
        }
        let d = dialogs.build({
            title: "Iniciar grabación...",
            progress: {
                max: -1
            },
            cancelable: false
        }).show();
        //重指
        for (let ii = 0; ii < TouchPointRecord.length; ii++) {
            let x = Math.floor(TouchPointCurrent[ii][0] + vrx);
            let y = Math.floor(TouchPointCurrent[ii][1] + vry);
            gesturesAry.push(TouchPointRecord[ii]);
            TouchPointRecord[ii] = [jishi * Ts, 0, [x, y]]
        };


        MainGesturesAry = new Array;
        MainResAry = new Array;
        MainClAry = new Array;
        MainDsqAry = new Array;
        ActionName = new Array;
        ChanceArr = new Array;
        ChanceLimitArr = new Array;
        WordArr = new Array;

        ActionName_test = new Array;

        af.Refresh(reDraw);
        toastLog("Acción de vaciado");
        setTimeout(()=>{
            nowPkg = currentPackage();
        },2000)
        setTimeout(() => {
            first_click = true; //第一次点击
            timestamp = (new Date()).valueOf();//获取当前毫秒的时间戳，准确！
            v.setText("Grabación");
            win_.but_l.attr("bg", "#d11410");
            win.setTouchable(true);
            d.dismiss();
        }, 1000);
    };
});
win_.but_p.click(function (v) {
    win_.but_l.attr("bg", "#77ffffff");
    win_.but_l.setText("Grabar una escena normal");
    win.setTouchable(false);
    threads.start(function () {
        ui.run(() => {
            v.setText("En marcha...");
            win.setTouchable(false);
            win_.setTouchable(false);
        });
        sleep(250);
        let gesturesAry_test = MainGesturesAry;

        let resAry_test = MainResAry;
        let clAry_test = MainClAry;
        let dsqAry_test = MainDsqAry;
        let ac_name = ActionName_test;
        let word_text = WordArr;
        let hasId = false;//是否有id

        for (let i = 0; i < resAry_test.length; i++) {
            let item = resAry_test[i][0];
            switch (ac_name[i]) {
                case '点击':
                    toastLog("click");
                    if(lz_mode == 'fast'){
                        gestures.apply(null, gesturesAry_test[i]);
                    }else{
                        let resId = item.id;
                        if (resId) {
                            hasId = true;
                            let resIdF = id(resId).visibleToUser().find();
                            if (resIdF) {
                                resIdF = resIdF.filter(function (uiObj) {
                                    if (uiObj) {
                                        let rect = uiObj.bounds();
                                        return common.checkRes(uiObj, item);
                                    }
                                });
                            }

                            if (resIdF && resIdF.length > 0) {

                                resIdF = resIdF[resIdF.length - 1];
                                let x = resIdF.bounds().centerX();
                                let y = resIdF.bounds().centerY();

                                if (item.clickable == true) {
                                    resIdF.click();
                                } else {
                                    click(x, y);
                                }
                                sleep(1000);

                            }
                        } else {
                            hasId = false;
                        }
                        if (!hasId) {
                            // log("没得节点id");
                            // if (item.length == 4) {
                            //     toastLog("148:滑动");
                            //     gestures.apply(null, gesturesAry_test[i]);
                            // } else {
                                let des = className(item.className).find();
                                if (des) {
                                    des = des.filter(function (uiObj) {
                                        if (uiObj) {
                                            let rect = uiObj.bounds();
                                            if (uiObj.visibleToUser()) {
                                                return common.checkResNoId(uiObj, item);
                                            }
                                        }
                                    });
                                }

                                if (des && des.length > 0) {
                                    click(des[0].bounds().centerX(), des[0].bounds().centerY());
                                    sleep(3000);
                                }

                            // }

                        }
                    }
                    try{

                        if (dsqAry_test.length == 1) {
                            toastLog("Espera" + dsqAry_test[i][0][0] / 1000 + "s");
                            sleep(dsqAry_test[i][0][0]);
                        } else {
                            toastLog("Espera" + dsqAry_test[i + 1][0][0] / 1000 + "s");
                            sleep(dsqAry_test[i + 1][0][0]);
                        }
                    }catch(e){
                        toastLog("Por favor, espere 0.5s");
                        sleep(300);
                    }
                    continue;
                    break;
                case '滑动':
                    toastLog("Deslizamiento");
                    gestures.apply(null, gesturesAry_test[i]);
                    sleep(3000);
                    continue;
                    break;
                case '文字':
                    toastLog("Texto");

                    let str_ = word_text[i];
                    let str = str_[random(0,str_.length-1)];
                    setText(str);
                    sleep(2000);
                    continue;
                    break;
                default:
                    break;
            }


        };
        ui.run(() => {
            win_.setTouchable(true);
            if (win_.but_l.getText() == "Grabación") {
                win.setTouchable(true);
            } else {
                win.setTouchable(false);
            };
            v.setText("Ejecutar grabación");
        });
        toastLog("complete");
    });
});



win_.but_s.click(function () {
    setClip("let gesturesAry=" + JSON.stringify(MainGesturesAry)
        + ";\n"
        + "let resAry = " + JSON.stringify(MainResAry) + ";"
        + "\n"
        +"let clAry = " + JSON.stringify(MainClAry) + ";"
        +"let dsqAry = " + JSON.stringify(MainDsqAry) + ";"
        +"let ActionName = " + JSON.stringify(ActionName) + ";\n"
        +"let ChanceArr = " + JSON.stringify(ChanceArr) + ";\n"
        +"let WordArr = " + JSON.stringify(WordArr) + ";\n");
});



expor.but_g.click(function () {
    exit();
});

win_.but_e.click(function () {
    if (win_.but_e.getText() == "Desenrollar") {
        win_.but_e.setText("Zoom");
        win_.left_main.attr("visibility", "visible");
        setTimeout(()=>{expor.setPosition(win_.getX(),win_.getY()+win_.height);},50);
    } else {
        win_.but_e.setText("Zoom");
        win_.left_main.attr("visibility", "gone");
        setTimeout(()=>{expor.setPosition(win_.getX(),win_.getY()+win_.height);},50);
    }


});






function reDraw(canvas) {
    //canvas.drawARGB(255, 127, 127, 127);
    let w = canvas.getWidth();
    let h = canvas.getHeight();
    let AX = w / 2;
    let AY = h / 2;

    paint.setStyle(Paint.Style.STROKE);
    canvas.drawText(now_mode+' Patrón. Grabado: '+String(MainGesturesAry.length + " Acción"), 10, textSize, paint);

    if (TouchPointStart.length) {

        for (let i = 0; i < TouchPointStart.length; i++) {
            try {
                let X = TouchPointStart[i][0];
                let Y = TouchPointStart[i][1];
                let x = TouchPointCurrent[i][0];
                let y = TouchPointCurrent[i][1];
                X = X || 0;
                Y = Y || 0;
                x = x || 0;
                y = y || 0;
                let a = X - (x - X);
                let b = Y - (y - Y);
                //let rect = new android.graphics.RectF(X, Y, x, y);
                //canvas.drawRect(rect, paint);
                //let rect2 = new android.graphics.RectF(X, Y, a, b);
                //canvas.drawRect(rect2, paint);
                //let rect3 = new android.graphics.RectF(x, y, a, b);
                //canvas.drawRect(rect3, paint);
                //canvas.drawLine(X, Y, x, y, paint);
                //canvas.drawLine(X, Y, a, b, paint);
                canvas.drawText(String("A"), X, Y, paint);
                canvas.drawText(String("B"), x, y, paint);
                canvas.drawCircle(X, Y, 10, paint);
                canvas.drawCircle(x, y, 10, paint);
                //canvas.drawCircle(a, b, 10, paint);
            } catch (e) { log(getError(e)) };
        };
        for (let ii = 0; ii < TouchPointRecord.length; ii++) {
            let ge = TouchPointRecord[ii];
            canvas.drawText(String("*"), ge[0] / 10 * ii + jishi * Ts / 25, textSize * (ii + 2), paint)
            for (let i = 2; i < ge.length - 1; i++) {

                let X = ge[i][0] - vrx;
                let Y = ge[i][1] - vry;
                let x = ge[i + 1][0] - vrx;
                let y = ge[i + 1][1] - vry;
                X = X || 0;
                Y = Y || 0;
                x = x || 0;
                y = y || 0;
                //let a = X - (x - X);
                //let b = Y - (y - Y);
                //let rect = new android.graphics.RectF(X, Y, x, y);
                //canvas.drawRect(rect, paint);
                //let rect2 = new android.graphics.RectF(X, Y, a, b);
                //canvas.drawRect(rect2, paint);
                //let rect3 = new android.graphics.RectF(x, y, a, b);
                //canvas.drawRect(rect3, paint);
                canvas.drawLine(X, Y, x, y, paint);
                //canvas.drawLine(X, Y, a, b, paint);
                //canvas.drawText(String("A"), X, Y, paint)
                //canvas.drawText(String("B"), x, y, paint);
                //canvas.drawCircle(X, Y, 10, paint);
                //canvas.drawCircle(x, y, 10, paint);
                //canvas.drawCircle(a, b, 10, paint);
            };
        };
    };

};


let isMove = false; //滑动判定
let downX, downY //按下时的坐标
let upX, upY //松开时的坐标





function 反色(color) {
    return (-1 - colors.argb(0, colors.red(color), colors.green(color), colors.blue(color)));
};

function toJavaArray(type, ary) {
    //let Ary = java.lang.reflect.Array.newInstance(		java.lang.Float.TYPE, 4);
    let Ary = util.java.array(type, ary.length);
    for (let i in ary) {
        Ary[i] = ary[i];
    };
    return Ary;
};

function SolvePos(a, b, r, k, c) {
    let a1 = k * k + 1;
    let b1 = 2 * k * (c - b) - 2 * a;
    let c1 = a * a + (c - b) * (c - b) - r * r;
    let delta = b1 * b1 - 4 * a1 * c1;
    let result = [];
    if (delta == 0) {
        let x0 = Math.sqrt(delta);
        let x1 = -b1 / (2 * a1);
        let y1 = k * x1 + c;
        result.push(x1, y1);
    } else if (delta > 0) {
        let x0 = Math.sqrt(delta);
        let x1 = (-b1 - x0) / (2 * a1);
        let y1 = k * x1 + c;
        result.push(x1, y1);
        let x2 = (-b1 + x0) / (2 * a1);
        let y2 = k * x2 + c;
        result.push(x2, y2);
    }
    return result;
};

function weiyi(ary) {
    let sum = 0;
    for (let i = 0; i < ary.length; i++) {
        sum += Math.pow(ary[i], 2);
    };
    return Math.sqrt(sum);
};

function kdfx(Y) {
    let x = Math.cos(Y % 360 / 360 * 2 * Math.PI);
    let y = Math.sin(Y % 360 / 360 * 2 * Math.PI);
    return {
        x: x,
        y: y
    };
};

function ydfx(obj) {
    let ary = getsd(1, [obj.x, obj.y]);
    let x = ary[0],
        y = ary[1];
    let Y = Math.asin(y) / (2 * Math.PI) * 360;
    if (x < 0) {
        Y = 180 - Y;
    };
    return Y;
};

function getsd(s, ary) {
    let sum = weiyi(ary);
    let S = s / sum;
    for (let i = 0; i < ary.length; i++) {
        ary[i] = ary[i] * S;
    };
    return ary;
};

function XYTOAB(x, y, x1, y1) {
    let A = (y1 - y) / (x1 - x);
    let B = y - A * x;
    return [A, B];
};



win.img.setOnTouchListener(new android.view.View.OnTouchListener((view, event) => {
    try {
        let W = view.getWidth();
        let H = view.getHeight();
        let PC = event.getPointerCount();
        switch (event.getActionMasked()) {
            case event.ACTION_MOVE:
                // log("ACTION_MOVE");

                isMove = true;
                for (let i = 0; i < PC; i++) {
                    let id = event.getPointerId(i);
                    let X = event.getX(i);
                    let Y = event.getY(i);
                    TouchPointCurrent[i][0] = X;
                    TouchPointCurrent[i][1] = Y;
                };

                break;
            case event.ACTION_CANCEL:
                // log("CANCEL");
                kg = false;
                jishi = 0;

                TouchPointStart = new Array;
                TouchPointCurrent = new Array;
                TouchPointRecord = new Array;

                break;
            case event.ACTION_OUTSIDE:
                // log("OUTSIDE");

                break;
            default:
                let I = Math.floor(event.getAction() / 256);
                let ID = event.getPointerId(I);
                let X = event.getX(I);
                let Y = event.getY(I);
                let RX = event.getRawX();
                let RY = event.getRawY();
                let touch_click = true;//正常点击
                // log("default:" + 'X:' + X + 'Y:' + Y);
                switch (event.getActionMasked()) {
                    case event.ACTION_DOWN:

                        let now_time = (new Date()).valueOf();
                        let time_interval = now_time - timestamp; //间隔 单位毫秒
                        dsqAry.push([time_interval]);
                        timestamp = now_time;

                        downX = event.getRawX();
                        downY = event.getRawY();

                        vrx = RX - X, vry = RY - Y;
                        kg = true;
                        TouchPointRecord.splice(I, 0, [0, 1, [Math.floor(X + vrx), Math.floor(Y + vry)]]);
                        TouchPointStart.splice(I, 0, [X, Y]);
                        TouchPointCurrent.splice(I, 0, [X, Y]);
                        isMove = true;

                        break;
                    case event.ACTION_UP:

                        upX = event.getRawX();
                        upY = event.getRawY();
                        // 饿->吃->渴->喝-------
                        // ↑                   ↓
                        // |------------------ |
                        kg = false;
                        jishi = 0;
                        // log("TouchPointRecord[I]:" + TouchPointRecord[I]);
                        gesturesAry.push(TouchPointRecord[I]);
                        MainGesturesAry.push(gesturesAry);
                        // log("滑动距离X："+Math.abs(parseInt(upX) - parseInt(downX)));
                        // log("滑动距离Y："+Math.abs(parseInt(upY) - parseInt(downY)));
                        //是否是滑动
                        if (isMove) {

                            if ((Math.abs(parseInt(upX) - parseInt(downX)) >= 100) || (Math.abs(parseInt(upY) - parseInt(downY)) >= 100)) {
                                toastLog("Deslizamiento");
                                ActionName.push("Deslizamiento");
                                ActionName_test.push("滑动");
                                touch_click = false;
                                resAry.push(TouchPointRecord[I]);
                                clAry.push([parseInt(downX), parseInt(downY), parseInt(RX), parseInt(RY)]);
                            } else {
                                log("正常点击1");
                                touch_click = true;
                                // resAry.push(getRes(parseInt(RX), parseInt(RY)));
                                clAry.push([parseInt(upX), parseInt(upY)]);
                            }
                        } else {
                            log("正常点击");
                            touch_click = true;
                            // resAry.push(getRes(parseInt(RX), parseInt(RY)));

                            clAry.push([parseInt(upX), parseInt(upY)]);
                        }

                        currentPkg = currentPackage();

                        currentAppName = getAppName(currentPkg);

                        if (touch_click) {
                            ActionName.push("Click");
                            ActionName_test.push("点击");

                            if(lz_mode != 'fast'){
                                let click_ = common.getRes(RX,RY);
                                resAry.push(click_);
                            }
                            // resAry.push({'节点':[parseInt(upX),parseInt(upY)]});
                        }
                        WordArr.push('');
                        ChanceArr.push("100%");
                        ChanceLimitArr.push(true);
                        MainResAry.push(resAry);
                        MainClAry.push(clAry);
                        MainDsqAry.push(dsqAry);



                        gesturesAry = new Array;
                        resAry = new Array;
                        clAry = new Array;
                        dsqAry = new Array;


                        TouchPointStart = new Array;
                        TouchPointCurrent = new Array;
                        TouchPointRecord = new Array;

                        threads.start(function () {
                            ui.run(() => {
                                win.setTouchable(false);
                                win_.setTouchable(false);
                            });
                            // log(MainGesturesAry);
                            sleep(250);
                            try {
                                toastLog("En respuesta...");
                                gestures.apply(null, MainGesturesAry[MainGesturesAry.length - 1]);
                            } catch (e) {
                                log(getError(e));
                                MainGesturesAry.pop();
                                MainResAry.pop();
                                MainClAry.pop();
                                MainDsqAry.pop();
                                ActionName.pop();
                                ChanceArr.pop();
                                ChanceLimitArr.pop();
                                WordArr.pop();
                                ActionName_test.pop();

                                af.Refresh(reDraw);
                                toastLog("Por favor, regístrese para una operación que ha sido retirada");
                            }

                            sleep(250);
                            ui.run(() => {
                                win_.setTouchable(true);

                                    if (win_.but_l.getText() == "Grabación") {
                                        win.setTouchable(true);
                                    } else {
                                        win.setTouchable(false);
                                    };


                            });
                        });

                        isMove = false;
                        break;
                    case event.ACTION_POINTER_DOWN:
                        // log("POINTER_DOWN");
                        TouchPointRecord.splice(I, 0, [jishi * Ts, 1, [Math.floor(X + vrx), Math.floor(Y + vry)]]);
                        TouchPointStart.splice(I, 0, [X, Y]);
                        TouchPointCurrent.splice(I, 0, [X, Y]);


                        break;
                    case event.ACTION_POINTER_UP:
                        // log("POINTER_UP:" + TouchPointRecord[I]);
                        gesturesAry.push(TouchPointRecord[I]);

                        TouchPointStart.splice(I, 1);
                        TouchPointCurrent.splice(I, 1);
                        TouchPointRecord.splice(I, 1);

                        break;
                };
        };
    } catch (e) {
        log(getError(e));
    };
    af.Refresh(reDraw);
    return true;
}));

//输入对话弹框 ui
function inputFloaty() {
        win.setTouchable(false);
        rawInput("Please enter the text to send", "").then(win_input => {
            if (win_input) {
                let str = win_input;
                if (str) {
                        let str_ = str.split("#");
                        str = str_[random(0,str_.length-1)];
                        // log(MainGesturesAry);
                        // gesturesAry.push(str);
                        MainGesturesAry.push(str);
                        MainResAry.push([str]);
                        MainClAry.push(str);
                        ActionName.push("Texto");
                        ActionName_test.push("文字");
                        ChanceArr.push("100%");
                        ChanceLimitArr.push(true);
                        WordArr.push(str_);

                        let now_time = (new Date()).valueOf();
                        let time_interval = now_time - timestamp; //间隔 单位毫秒
                        dsqAry.push([time_interval]);
                        timestamp = now_time;
                        MainDsqAry.push(dsqAry);//间隔时间
                        setTimeout(()=>{
                            setText(str);
                            win.setTouchable(true);
                        },500);
                        // log('459MainGesturesAry:'+MainGesturesAry);

                } else {
                    toastLog("Texto no introducido");
                }

            }
            win.setTouchable(true);
        });


}

word_.word_list.on("item_bind", function (itemView, itemHolder) {
    //绑定勾选框事件
    itemView.word_y.on("click", function () {
        let item = itemHolder.item;
        toastLog("La plantilla de palabras que ha elegido es" + item.name);
        let str_ = item.content.split("#");
        let str = str_[random(0,str_.length-1)];
        MainGesturesAry.push(str);
        MainResAry.push([str]);
        MainClAry.push(str);
        ActionName.push("Texto");
        ActionName_test.push("文字");
        ChanceArr.push("100%");
        ChanceLimitArr.push(true);
        WordArr.push(str_);

        let now_time = (new Date()).valueOf();
        let time_interval = now_time - timestamp; //间隔 单位毫秒
        dsqAry.push([time_interval]);
        timestamp = now_time;
        MainDsqAry.push(dsqAry);//间隔时间
        setTimeout(()=>{
            setText(str);
            word_.word_.attr("visibility","gone");
            win.setTouchable(true);
        },500);
    });
});

if(win_){
    win_.but_h.click(() => {
        win.setTouchable(false);
                let a = dialogs.build({
                title: "Operaciones",
                items: ["Quiero escribir yo mismo","Lo pedí mal"],
                itemsSelectMode: "single",
                itemsSelectedIndex: 0,
                cancelable:false
            }).on("single_choice", (k, v)=>{

            switch (k) {
                case 0:
                    inputFloaty();
                    break;
                case 1:
                    win.setTouchable(true);
                    break;
                default:
                    break;
            }
            }).show();

    });

    win_.but_hh.click(()=>{
        try{
            let word_thread;
            if(word_.word_.attr("visibility")=="gone"){
                word_thread = threads.start(function(){
                    let a = request.post("api/getWords",{
                        code:storage.getStr("code")
                    });
                    if(a.code == 0){
                        ui.run(()=>{
                            let words = a.data;
                            word_.word_list.setDataSource(words);
                            toastLog("Lista desplegada de plantillas de habla (ver a la derecha)");
                            word_.word_.attr("visibility","visible");
                        })
                    }
                    

                });

            }else{
                toastLog("Lista de plantillas de llamadas cerradas");
                word_.word_.attr("visibility","gone");
            }
        }catch(e){
            alert(getError(e));
        }
    });

    win_.but_b.click(function () {
        win_.but_l.attr("bg", "#77ffffff");
        win_.but_l.setText("Grabar una escena normal");

        win.setTouchable(false);

        threads.start(function () {
            try {
                let item_uuid = common.uuid(8, 62);
                let f = dialogs.prompt("Ruta guardada", "Acción1");

                if (f) {
                    let id_num = common.getUnique();
                    if (id_num === '') {
                        alert("Compruebe los permisos de aplicación!");
                        return false;
                    }
                    let checkUnique = request.post("api/checkFileUnique",{
                        code:storage.getStr("code"),
                        identifier:item_uuid
                    });
                    if(checkUnique.code != '0'){
                        log("重新生成标识");
                        item_uuid = common.uuid(8, 62);
                    }

                    let ff = lzdir + f +'_'+item_uuid + ".js";
                    let pkgNameIndex = appNames.indexOf(currentAppName);
                    // dialogs.build({
                    //     title: "Seleccione la aplicación en la que se ejecuta el escenario",
                    //     items: appNames,
                    //     itemsSelectMode: "single",
                    //     cancelable:false,
                    //     itemsSelectedIndex: pkgNameIndex>=0?pkgNameIndex:0
                    // }).on("single_choice", (index, item)=>{
                        let app_version = common.getPackageVersion(nowPkg);
                        let drawable_now = common.getDrawable();
                        let f_name = common.getFileName(ff);
                        let f_text = f_name.substring(0,f_name.indexOf("_"));

                        let obj_one = {
                            "uuid": item_uuid,
                            "id": id_num,
                            "text": f_text,
                            "path": ff,
                            "drawable": drawable_now,
                            "run_time":'10',
                            "run_app":[appInfo[nowPkg],nowPkg,app_version],
                            "app_appName":appInfo[nowPkg],
                            "app_appPkg":nowPkg,
                            "app_version":app_version,
                            "lz_mode":lz_mode.toString(),
                            "gesturesAry":MainGesturesAry,
                            "ActionName":ActionName,
                            "ActionName_test":ActionName_test,
                            "ChanceArr":ChanceArr,
                            "ChanceLimitArr":ChanceLimitArr,
                            "WordArr":WordArr,
                            "clAry":MainClAry,
                            "dsqAry":MainDsqAry,
                            "fileType":8
                        };

                        let script =
                        "let Config = "+JSON.stringify(obj_one)+";"
                        + "let resAry = " + JSON.stringify(MainResAry) + ";"
                        +"let storage = storages.create('Hodgepodge');"
                        + 'let show_ary = ["id", "text", "desc", "clickable", "className", "bounds","visibleToUser", "scrollable", "depth","getChildCount","getActionList","hashCode","getWindow","indexInParent"];'
                        + "let gesturesAry= Config.gesturesAry;"
                        +"let clAry = Config.clAry;"
                        +"let dsqAry = Config.dsqAry;"
                        +"let ActionName = Config.ActionName;"
                        +"let ActionName_test = Config.ActionName_test;"
                        +"let ChanceArr = Config.ChanceArr;"
                        +"let ChanceLimitArr = Config.ChanceLimitArr;"
                        +"let WordArr = Config.WordArr;"
                        +'let data_arr = {"gesturesAry":Config.gesturesAry,"ActionName":Config.ActionName,"ActionName_test":Config.ActionName_test,"ChanceArr":Config.ChanceArr,"WordArr":Config.WordArr,"clAry":Config.clAry,"dsqAry":Config.dsqAry,"resAry":resAry,"ChanceLimitArr":Config.ChanceLimitArr};'
                        +"let run_once=Config.fileType;let hasId=false;var run_mode=Config.lz_mode;var local_extraParams=Config.extraParams;var extraParams;var pollingInterval;var actionInterval;var TimerInfo=[];var isInterExtra=false;let run_data=engines.myEngine().execArgv.config;if(run_data&&JSON.stringify(run_data)!='{}'){if(run_data.local_run_data){}else if(run_data.run_data){run_data=run_data.run_data;if(JSON.stringify(run_data)!='{}'&&run_data){isInterExtra=true;if(run_data.extraParams){extraParams=run_data.extraParams;actionInterval=run_data.actionInterval}}}}accurate_main(data_arr);function accurate_main(data){for(let i=0;i<data.resAry.length;i++){let item=data.resAry[i][0];if(!chance(data.ChanceArr[i])){toastLog('该步骤不操作');continue}if(run_mode=='fast'){if(data.ActionName_test[i]=='文字'){let extraParams_='';let str_=(data.WordArr)[i];let str=str_[random(0,str_.length-1)];if(isInterExtra){if(!extraParams){toastLog('未填写该场景的额外参数!将使用录制参数')}else{if(extraParams.indexOf('#')>=0){extraParams_=extraParams.split('#');extraParams_=extraParams_[random(0,extraParams_.length-1)];str=extraParams_}if(extraParams_.indexOf('*')){extraParams_=extraParams_.split('*');extraParams_.forEach(function(item,index){setText(item);sleep(1000);click(data.clAry[i+1][0][0],data.clAry[i+1][0][1]);sleep(1000)});continue}}}setText(str);continue}gestures.apply(null,data.gesturesAry[i]);try{if(data.dsqAry.length==1){toastLog('等待'+data.dsqAry[i][0][0]/1000+'秒');sleep(data.dsqAry[i][0][0])}else{toastLog('等待'+data.dsqAry[i+1][0][0]/1000+'秒');sleep(data.dsqAry[i+1][0][0])}}catch(e){toastLog('请等待0.5秒');sleep(300)}continue}if(data.ActionName_test[i]=='点击'){let resId=item.id;if(resId){hasId=true;let resIdF=id(resId).visibleToUser().find();if(resIdF){try{resIdF=resIdF.filter(function(uiObj){if(uiObj){let rect=uiObj.bounds();return checkRes(uiObj,item)}})}catch(e){log('113:'+e);resIdF=null}}if(resIdF&&resIdF.length>0){resIdF=resIdF[resIdF.length-1];let x=resIdF.bounds().centerX();let y=resIdF.bounds().centerY();if(item.clickable==true){resIdF.click()}else{click(x,y)}sleep(1000)}}else{hasId=false}if(!hasId){let des=className(item.className).find();if(des){try{des=des.filter(function(uiObj){if(uiObj){let rect=uiObj.bounds();if(uiObj.visibleToUser()){return checkResNoId(uiObj,item)}}})}catch(e){log('101:'+e);resIdF=null}}if(des&&des.length>0){click(des[0].bounds().centerX(),des[0].bounds().centerY());sleep(3000)}}try{if(actionInterval){let tt=actionInterval;tt=tt.split("+");if(tt.length==2){tt=random(parseInt(tt[0]),parseInt(tt[1]))}else{tt=tt[0]}toastLog('等待'+tt+'秒');sleep(tt*1000)}else{if(data.dsqAry.length==1){toastLog('等待'+data.dsqAry[i][0][0]/1000+'秒');sleep(data.dsqAry[i][0][0])}else{toastLog('等待'+data.dsqAry[i+1][0][0]/1000+'秒');sleep(data.dsqAry[i+1][0][0])}}}catch(e){toastLog('请等待0.5秒');sleep(300)}continue}if(data.ActionName_test[i]=='滑动'){gestures.apply(null,data.gesturesAry[i]);try{if(actionInterval){let tt=actionInterval;tt=tt.split("+");if(tt.length==2){tt=random(parseInt(tt[0]),parseInt(tt[1]))}else{tt=tt[0]}toastLog('等待'+tt+'秒');sleep(tt*1000)}else{if(data.dsqAry.length==1){toastLog('等待'+data.dsqAry[i][0][0]/1000+'秒');sleep(data.dsqAry[i][0][0])}else{toastLog('等待'+data.dsqAry[i+1][0][0]/1000+'秒');sleep(data.dsqAry[i+1][0][0])}}}catch(e){toastLog('请等待0.5秒');sleep(300)}continue}if(data.ActionName_test[i]=='文字'){let str_=(data.WordArr)[i];let str=str_[random(0,str_.length-1)];if(isInterExtra){let extraParams_='';if(!extraParams){toastLog('未填写该昙花场景的额外参数!将使用录制参数')}else{str=extraParams;if(extraParams.indexOf('#')>=0){extraParams_=extraParams.split('#');extraParams_=extraParams_[random(0,extraParams_.length-1)];str=extraParams_}if(extraParams_.indexOf('*')>=0){extraParams_=extraParams_.split('*');extraParams_.forEach(function(item,index){setText(item);sleep(1000);click(data.clAry[i+1][0][0],data.clAry[i+1][0][1]);sleep(1000)});continue}}}else{if(str.indexOf('#')>=0){str=str.split('#');str=str[random(0,str.length-1)]}if(str.indexOf('*')){str=str.split('*');str.forEach(function(item,index){setText(item);sleep(1000);click(data.clAry[i+1][0][0],data.clAry[i+1][0][1]);sleep(1000)});continue}}setText(str);try{if(actionInterval){let tt=actionInterval;tt=tt.split("+");if(tt.length==2){tt=random(parseInt(tt[0]),parseInt(tt[1]))}else{tt=tt[0]}toastLog('等待'+tt+'秒');sleep(tt*1000)}else{if(data.dsqAry.length==1){toastLog('等待'+data.dsqAry[i][0][0]/1000+'秒');sleep(data.dsqAry[i][0][0])}else{toastLog('等待'+data.dsqAry[i+1][0][0]/1000+'秒');sleep(data.dsqAry[i+1][0][0])}}}catch(e){toastLog('请等待0.5秒');sleep(300)}continue}}}";
                        files.createWithDirs(ff); //确保文件存在
                        files.write(ff, script);
                        toastLog("¡Guardar éxito! ¡Si la lista de grabación no se muestra, por favor actualice!");
                    // }).show();

                };
            } catch (e) {
                log(getError(e));
                alert("Fallo al guardar");
            }
        });
    });

        /**
     * 异常捕获格式化输出
     * @param {*} e 
     * @returns 
     */
        function getError(e){
            return files.getNameWithoutExtension(e.fileName)+':line:' + e.lineNumber + ':'+e.message+';';
        }
}

