var common = require("./common");
var request = require("./request");
var storage = storages.create('Hodgepodge');
var storageAJ = storages.create("AJ动作录制");
var show_ary = ["id", "text", "desc", "clickable", "className", "bounds","visibleToUser", "scrollable", "depth","getChildCount","getActionList","hashCode","getWindow","indexInParent"];
var lz_mode = storage.getStr("record_mode");
var now_mode = (lz_mode=='fast')?"简易模式":"精准模式";
var currentAppName;
var nowPkg = null;
var currentPkg = currentPackage();
var pm = context.getPackageManager();
var appList=pm.getInstalledApplications(0);
var appInfoList=[];
var sheight = 0;
var wordExpend = false;
//var lz_path = context.getFilesDir()+"/douzhu/";
var lz_path = "/sdcard/records/";
toastLog("进入录制模式，请点开悬浮窗点击运行按钮即可开始录制！");
var resourceId = context.getResources().getIdentifier("status_bar_height", "dimen", "android");
if (resourceId > 0) {
    sheight = context.getResources().getDimensionPixelSize(resourceId);
}
var fileType = 8;
const W = device.width;
const H = device.height;


var floaty_all = {
    win:floaty.rawWindow(
        <frame id="frame" grivaty="center" alpha="1" w="{{W}}" h="{{H}}">
            <img id="img" w="{{W}}" h="{{H}}" />
        </frame>
    ),
    win_:floaty.rawWindow(
            <vertical gravity="center" alpha="0.6" padding="5 5">
                <img id="move" visibility="gone" src = "file://pic/move.png" w="30" h="30" marginTop="5"/>
                <text id="actions" visibility="gone" color="red" textSize="12" text="0" marginBottom="-13" marginLeft="16" />
                <img id="record" src = "file://pic/play.png" w="30" h="30" marginTop="5"/>
                <img id="word" src = "file://pic/word.png" w="30" h="30" marginTop="5" />
                <img id="input" src = "file://pic/input.png" w="30" h="30" marginTop="5" />
                <img id="exit" src = "file://pic/exit.png" w="30" h="30" marginTop="5" />
            </vertical>
    ),
    word_:floaty.rawWindow(
        <vertical id="word_" gravity="center" alpha="0.6" padding="5 5" visibility="visible">
            <scroll h="130">
                <list id="word_list">
                    <vertical>
                        <button ellipsize="end" id="word_y" text="{{this.name}}" w="100" h="35" bg="#FFFFFF" textSize="13sp" />
                        <View h="1" w="*" bg="#5DAA54" />
                    </vertical>
                </list>
            </scroll>
        </vertical>
    )
}

var timestamp;//时间戳计时
var win = floaty_all.win;
var win_ = floaty_all.win_;
win_.setPosition(0,H*0.4);
var word_ = floaty_all.word_;

word_.setPosition(win_.getX()+win_.width,win_.getY());
for(let i=0;i<appList.size();i++){
    let app=appList.get(i);
    let appInfo={
        appName:app.loadLabel(pm),
        packageName:app.packageName,
    }
    appInfoList.push(appInfo);
}

appInfoList.sort((a,b)=>{
    return b.firstInstallTime-a.firstInstallTime;
});

var appNames = [];
var appPkgs = [];
let appInfo = [];
appInfoList.forEach(function(item,index){
    appNames.push(item.appName);
    appPkgs.push(item.packageName);
    appInfo[item.packageName] = item.appName;
});



var af = null;

var ad = new 悬浮控制(win, null, true);

// new 悬浮控制(win, floaty_all.win_.move, true);

win.setSize(1, 1);
win.setTouchable(false);

var paint = new Paint;
//paint.setTextAlign(Paint.Align.CENTER);
paint.setStrokeWidth(5);
paint.setStyle(Paint.Style.STROKE);
paint.setARGB(255, 91, 205, 96);
var textSize = 50;
paint.setTextSize(textSize);


//每次动作。
var MainGesturesAry = new Array; //↓↓↓↓
var MainResAry = new Array; //↓↓↓↓
var MainClAry = new Array; //↓↓↓↓
var MainDsqAry = new Array; //↓↓↓↓
var ActionName = new Array; //↓↓↓↓
var ChanceArr = new Array;
var WordArr = new Array; //话术
var ChanceLimitArr = new Array; //概率修改限制

var ActionName_test = new Array; //↓↓↓↓
//一次中的手指动作。
var gesturesAry = new Array; //手势集合↓↓↓↓[[0,100,[x1,y1],[x2,y2],[x3,y3],[x4,y4],………],………]
var resAry = new Array; //节点集合
var clAry = new Array(); //点击坐标集合
var dsqAry = new Array(); //间隔时间 集合
//每个手指的动作。
var TouchPointRecord = new Array; //[[0,1000,[x1,y1],………],………]

var TouchPointStart = new Array; //[[x1,y1],[x2,y2],[x3,y3],[x4,y4],………]
var TouchPointCurrent = new Array; //[[x1,y1],[x2,y2],[x3,y3],[x4,y4],………]

var vrx = 0,
    vry = 0; //屏幕坐标差。
var Ts = 50; //动作精度。越小精度越高。//但实际上没卵用。自动操作函数gestures会自动缩减
var Tss = 400; //动作间隔
var kg = false;
var jishi = 0;


setInterval(() => {
    if (kg) {
        jishi++;
        for (let i = 0; i < TouchPointRecord.length; i++) {
            try {
                let x = Math.floor(TouchPointCurrent[i][0] + vrx);
                let y = Math.floor(TouchPointCurrent[i][1] + vry);
                TouchPointRecord[i].push([x, y]);
                TouchPointRecord[i][1] += Ts;
            } catch (e) {
                break;
            };
        };
    };
}, Ts);

function startRecord(){
    clearRecord();
    ui.run(()=>{

        confirm("是否开启精准录制？").then(value=>{
            if (value) {
                lz_mode = "accurate";
            }else{
                lz_mode = "fast";
            }
            win.setSize(W, H);
            af = new 绘布(win.img);
            ad = new 悬浮控制(win, null, true);
            af.isOK();
            af.Refresh(reDraw);
            win.setTouchable(true);
            win_.actions.attr("visibility","visible");
            first_click = true; //第一次点击
            timestamp = (new Date()).valueOf();//获取当前毫秒的时间戳，准确！
        });
    });
}

function stopRecord(){
    ui.run(() => {
        win_.actions.attr("visibility","gone");
        win.setTouchable(false);
        win.setSize(1, 1);
    });
}

function clearRecord(){
    //重指
    for (let ii = 0; ii < TouchPointRecord.length; ii++) {
        let x = Math.floor(TouchPointCurrent[ii][0] + vrx);
        let y = Math.floor(TouchPointCurrent[ii][1] + vry);
        gesturesAry.push(TouchPointRecord[ii]);
        TouchPointRecord[ii] = [jishi * Ts, 0, [x, y]]
    };

    MainGesturesAry = new Array;
    MainResAry = new Array;
    MainClAry = new Array;
    MainDsqAry = new Array;
    ActionName = new Array;
    ChanceArr = new Array;
    ChanceLimitArr = new Array;
    WordArr = new Array;

    ActionName_test = new Array;
    if(af!=null){
        af.Refresh(reDraw);
    }

    toastLog("清空动作");
}

function saveRecord(){
    threads.start(function(){
        try {
            win.setTouchable(false);
            let item_uuid = common.uuid(8, 62);
            let f = dialogs.prompt("保存路径", "动作1");

            if (f) {
                    let id_num = common.getUnique();
                    if (id_num === '') {
                        alert("请检查一下应用权限!");
                        return false;
                    }
                    let checkUnique = request.post("api/checkFileUnique",{
                        code:storage.getStr("code"),
                        identifier:item_uuid
                    });
                    if(checkUnique.code != '0'){
                        log("重新生成标识");
                        item_uuid = common.uuid(8, 62);
                    }

                    let ff = lz_path + f +'_'+item_uuid + ".js";
                    let pkgNameIndex = appNames.indexOf(currentAppName);

                        let app_version = common.getPackageVersion(nowPkg);
                        let drawable_now = common.getDrawable();
                        let f_name = common.getFileName(ff);
                        let f_text = f_name.substring(0,f_name.indexOf("_"));

                        let obj_one = {
                           "uuid": item_uuid,
                            "id": id_num,
                            "text": f_text,
                            "path": ff,
                            "drawable": drawable_now,
                            "run_time":'10',
                            "run_app":[appInfo[nowPkg],nowPkg,app_version],
                            "app_appName":appInfo[nowPkg],
                            "app_appPkg":nowPkg,
                            "app_version":app_version,
                            "lz_mode":lz_mode.toString(),
                            "gesturesAry":MainGesturesAry,
                            "ActionName":ActionName,
                            "ActionName_test":ActionName_test,
                            "ChanceArr":ChanceArr,
                            "ChanceLimitArr":ChanceLimitArr,
                            "WordArr":WordArr,
                            "clAry":MainClAry,
                            "dsqAry":MainDsqAry,
                            "fileType":8,
                            "gg":1
                        };
                        let script =
                        "let Config = "+JSON.stringify(obj_one)+";"
                        + "let resAry = " + JSON.stringify(MainResAry) + ";"
                        +"let storage = storages.create('Hodgepodge');"
                        + 'let show_ary = ["id", "text", "desc", "clickable", "className", "bounds","visibleToUser", "scrollable", "depth","getChildCount","getActionList","hashCode","getWindow","indexInParent"];'
                        + "let gesturesAry= Config.gesturesAry;"
                        +"let clAry = Config.clAry;"
                        +"let dsqAry = Config.dsqAry;"
                        +"let ActionName = Config.ActionName;"
                        +"let ActionName_test = Config.ActionName_test;"
                        +"let ChanceArr = Config.ChanceArr;"
                        +"let ChanceLimitArr = Config.ChanceLimitArr;"
                        +"let WordArr = Config.WordArr;"
                        +'let data_arr = {"gesturesAry":Config.gesturesAry,"ActionName":Config.ActionName,"ActionName_test":Config.ActionName_test,"ChanceArr":Config.ChanceArr,"WordArr":Config.WordArr,"clAry":Config.clAry,"dsqAry":Config.dsqAry,"resAry":resAry,"ChanceLimitArr":Config.ChanceLimitArr};'
                        +"let run_once=Config.fileType;let hasId=false;var run_mode=Config.lz_mode;var local_extraParams=Config.extraParams;var extraParams;var pollingInterval;var actionInterval;var TimerInfo=[];var isInterExtra=false;let run_data=engines.myEngine().execArgv.config;if(run_data&&JSON.stringify(run_data)!='{}'){if(run_data.local_run_data){}else if(run_data.run_data){run_data=run_data.run_data;if(JSON.stringify(run_data)!='{}'&&run_data){isInterExtra=true;if(run_data.extraParams){extraParams=run_data.extraParams;actionInterval=run_data.actionInterval}}}}accurate_main(data_arr);function accurate_main(data){while(true){for(let i=0;i<data.resAry.length;i++){let item=data.resAry[i][0];if(!chance(data.ChanceArr[i])){toastLog('该步骤不操作');continue}if(run_mode=='fast'){if(data.ActionName_test[i]=='文字'){let extraParams_='';let str_=(data.WordArr)[i];let str=str_[random(0,str_.length-1)];if(isInterExtra){if(!extraParams){toastLog('未填写该场景的额外参数!将使用录制参数')}else{if(extraParams.indexOf('#')>=0){extraParams_=extraParams.split('#');extraParams_=extraParams_[random(0,extraParams_.length-1)];str=extraParams_}if(extraParams_.indexOf('*')){extraParams_=extraParams_.split('*');extraParams_.forEach(function(item,index){setText(item);sleep(1000);click(data.clAry[i+1][0][0],data.clAry[i+1][0][1]);sleep(1000)});continue}}}setText(str);continue}gestures.apply(null,data.gesturesAry[i]);try{if(data.dsqAry.length==1){toastLog('等待'+data.dsqAry[i][0][0]/1000+'秒');sleep(data.dsqAry[i][0][0])}else{toastLog('等待'+data.dsqAry[i+1][0][0]/1000+'秒');sleep(data.dsqAry[i+1][0][0])}}catch(e){toastLog('请等待0.5秒');sleep(300)}continue}if(data.ActionName_test[i]=='点击'){let resId=item.id;if(resId){hasId=true;let resIdF=id(resId).visibleToUser().find();if(resIdF){try{resIdF=resIdF.filter(function(uiObj){if(uiObj){let rect=uiObj.bounds();return checkRes(uiObj,item)}})}catch(e){log('113:'+e);resIdF=null}}if(resIdF&&resIdF.length>0){resIdF=resIdF[resIdF.length-1];let x=resIdF.bounds().centerX();let y=resIdF.bounds().centerY();if(item.clickable==true){resIdF.click()}else{click(x,y)}sleep(1000)}}else{hasId=false}if(!hasId){let des=className(item.className).find();if(des){try{des=des.filter(function(uiObj){if(uiObj){let rect=uiObj.bounds();if(uiObj.visibleToUser()){return checkResNoId(uiObj,item)}}})}catch(e){log('101:'+e);resIdF=null}}if(des&&des.length>0){click(des[0].bounds().centerX(),des[0].bounds().centerY());sleep(3000)}}try{if(actionInterval){let tt=actionInterval;tt=tt.split("+");if(tt.length==2){tt=random(parseInt(tt[0]),parseInt(tt[1]))}else{tt=tt[0]}toastLog('等待'+tt+'秒');sleep(tt*1000)}else{if(data.dsqAry.length==1){toastLog('等待'+data.dsqAry[i][0][0]/1000+'秒');sleep(data.dsqAry[i][0][0])}else{toastLog('等待'+data.dsqAry[i+1][0][0]/1000+'秒');sleep(data.dsqAry[i+1][0][0])}}}catch(e){toastLog('请等待0.5秒');sleep(300)}continue}if(data.ActionName_test[i]=='滑动'){gestures.apply(null,data.gesturesAry[i]);try{if(actionInterval){let tt=actionInterval;tt=tt.split("+");if(tt.length==2){tt=random(parseInt(tt[0]),parseInt(tt[1]))}else{tt=tt[0]}toastLog('等待'+tt+'秒');sleep(tt*1000)}else{if(data.dsqAry.length==1){toastLog('等待'+data.dsqAry[i][0][0]/1000+'秒');sleep(data.dsqAry[i][0][0])}else{toastLog('等待'+data.dsqAry[i+1][0][0]/1000+'秒');sleep(data.dsqAry[i+1][0][0])}}}catch(e){toastLog('请等待0.5秒');sleep(300)}continue}if(data.ActionName_test[i]=='文字'){let str_=(data.WordArr)[i];let str=str_[random(0,str_.length-1)];if(isInterExtra){let extraParams_='';if(!extraParams){toastLog('未填写该昙花场景的额外参数!将使用录制参数')}else{str=extraParams;if(extraParams.indexOf('#')>=0){extraParams_=extraParams.split('#');extraParams_=extraParams_[random(0,extraParams_.length-1)];str=extraParams_}if(extraParams_.indexOf('*')>=0){extraParams_=extraParams_.split('*');extraParams_.forEach(function(item,index){setText(item);sleep(1000);click(data.clAry[i+1][0][0],data.clAry[i+1][0][1]);sleep(1000)});continue}}}else{if(str.indexOf('#')>=0){str=str.split('#');str=str[random(0,str.length-1)]}if(str.indexOf('*')>-1){str=str.split('*');str.forEach(function(item,index){setText(item);sleep(1000);click(data.clAry[i+1][0][0],data.clAry[i+1][0][1]);sleep(1000)});continue}}toastLog(str);setText(str);try{if(actionInterval){let tt=actionInterval;tt=tt.split("+");if(tt.length==2){tt=random(parseInt(tt[0]),parseInt(tt[1]))}else{tt=tt[0]}toastLog('等待'+tt+'秒');sleep(tt*1000)}else{if(data.dsqAry.length==1){toastLog('等待'+data.dsqAry[i][0][0]/1000+'秒');sleep(data.dsqAry[i][0][0])}else{toastLog('等待'+data.dsqAry[i+1][0][0]/1000+'秒');sleep(data.dsqAry[i+1][0][0])}}}catch(e){toastLog('请等待0.5秒');sleep(300)}continue}}setenv('RunCount', parseInt(getenv('RunCount') || 0) + 1);setenv(Config.run_app[0] + '|' + Config.text + '|次数', 1);}}"
                        +"function chance(c){switch(c){case'100%':return true;break;case'75%':return(random(1,4)!=1);break;case'50%':return(random(1,2)==1);break;case'25%':return(random(1,4)==1);break;case'10%':return(random(1,10)==1);break;case'0%':return false;break;default:return false;break}}function checkRes(uiObj,it){if(uiObj){let arr2=[];let i=0;let class1=JSON.stringify(it['className']);let class2=JSON.stringify(uiObj.className());let text1=JSON.stringify(it['text']);let text2=JSON.stringify(uiObj.text());let depth1=JSON.stringify(it['depth']);let depth2=JSON.stringify(uiObj.depth());let hashCode1=JSON.stringify(it['hashCode']);let hashCode2=JSON.stringify(uiObj.hashCode());let desc1=JSON.stringify(it['desc']);let desc2=JSON.stringify(uiObj.desc());let getChildCount1=JSON.stringify(it['getChildCount']);let getChildCount2=JSON.stringify(uiObj.getChildCount());let getActionList1=JSON.stringify(it['getActionList']);let getActionList2=JSON.stringify(uiObj.getActionList());let getWindow1=JSON.stringify(it['getWindow']);let getWindow2=JSON.stringify(uiObj.getWindow());let clickable1=JSON.stringify(it['clickable']);let clickable2=JSON.stringify(uiObj.clickable());for(let index=0;index<show_ary.length;index++){let item=show_ary[index];let condition_zero=function(){if(!!text1&&!!text2){if(text1==text2&&desc1==desc2){return true}}return false};let condition_one=(condition_zero&&getChildCount1==getChildCount2);let condition_two=(hashCode1==hashCode2&&getWindow1==getWindow2);let condition_three=(depth1==depth2&&class1==class2&&getChildCount1==getChildCount2&&getActionList1==getActionList2);if((it['id']==uiObj.id())&&uiObj.visibleToUser()){if(it['id']){if(condition_one){return true}if(condition_two){return true}if(condition_three){return true}}}}return false}}function checkResNoId(uiObj,it){if(uiObj){let arr2=[];let i=0;let class1=JSON.stringify(it['className']);let class2=JSON.stringify(uiObj.className());let text1=JSON.stringify(it['text']);let text2=JSON.stringify(uiObj.text());let depth1=JSON.stringify(it['depth']);let depth2=JSON.stringify(uiObj.depth());let hashCode1=JSON.stringify(it['hashCode']);let hashCode2=JSON.stringify(uiObj.hashCode());let desc1=JSON.stringify(it['desc']);let desc2=JSON.stringify(uiObj.desc());let getChildCount1=JSON.stringify(it['getChildCount']);let getChildCount2=JSON.stringify(uiObj.getChildCount());let getActionList1=JSON.stringify(it['getActionList']);let getActionList2=JSON.stringify(uiObj.getActionList());let getWindow1=JSON.stringify(it['getWindow']);let getWindow2=JSON.stringify(uiObj.getWindow());let clickable1=JSON.stringify(it['clickable']);let clickable2=JSON.stringify(uiObj.clickable());for(let index=0;index<show_ary.length;index++){let item=show_ary[index];let uiobj_item=eval('uiObj.'+item+'()');let condition_zero=(function(){if(!!text1&&!!text2){if(text1==text2&&desc1==desc2){return true}}return false}());let condition_one=(condition_zero);let condition_two=(hashCode1==hashCode2&&getWindow1==getWindow2);let condition_three=(depth1==depth2&&class1==class2&&getChildCount1==getChildCount2&&getActionList1==getActionList2);let condition_four=(function(){if((text1==text2)||(text1==desc2)||(desc1==text2)||(desc2==desc1)){return true}return false}());if(condition_zero){if(condition_two){return true}if(condition_three){return true}return true}if(JSON.stringify(it[item])==JSON.stringify(uiobj_item)){i++}}if(i>=13){log('匹配成功'+i);return true}log('匹配失败'+i);return false}}";
                        files.createWithDirs(ff); //确保文件存在
                        files.write(ff, script);
                        toastLog("保存成功!若录制列表未显示请刷新！");
                };
        } catch (e) {
            log(getError(e));
            alert("保存失败"+getError(e));
        }
    });
}

function wordSelf(){
    win.setTouchable(false);
    inputFloaty();
}


function wordModel(){
    try{
        let word_thread;
        if(!wordExpend){
            toastLog("正在准备展开话术模板...");
            word_thread = threads.start(function(){
                let a = request.post("api/getWords",{
                    code:storage.getStr("code")
                });
                if(a.code == 0){
                    ui.run(()=>{
                        word_.setPosition(win_.getX()+win_.width,win_.getY());
                        let words = a.data;
                        word_.word_list.setDataSource(words);
                        toastLog("已展开话术模板列表(请看右侧)");
                        word_.word_.attr("visibility","visible");
                        wordExpend = true;
                    });
                }else{
                    toastLog("暂无话术模板！请先新建模板！");
                }
            });

        }else{
            ui.run(()=>{
                toastLog("已关闭话术模板列表");
                word_.word_.attr("visibility","gone");
                word_.setPosition(-500,0);
                wordExpend = false;
            });
        }
    }catch(e){
        alert(getError(e));
    }
}

win_.record.click(function (v) {
    let but_l_src = win_.record.attr("src");
    if(but_l_src=="file://pic/play.png"){
        win_.record.attr("src","file://pic/stop.png");
        startRecord();
        toastLog("开始录制");
    }else{
        win_.record.attr("src","file://pic/play.png");
        saveRecord()
        stopRecord();
    }
});

win_.word.click(function (v) {
    wordModel();
});

win_.input.click(function (v) {
    wordSelf();
});

win_.exit.click(function (v) {
//    if(MainGesturesAry.length>0){
//        ui.run(()=>{
//            confirm("检测到您已录制了动作，是否保存？").then(value=>{
//                if(value){
//                    //保存录制的动作
//                    saveRecord();
//                    return;
//                }else{
//                    clearRecord();
//                }
//            });
//        });
//    }
    exit();
});



word_.word_list.on("item_bind", function (itemView, itemHolder) {
    //绑定勾选框事件
    itemView.word_y.on("click", function () {
        let item = itemHolder.item;
        toastLog("您选择的话术模板是" + item.name);
        let str_ = item.content.split("#");
        let str = str_[random(0,str_.length-1)];
        MainGesturesAry.push(str);
        MainResAry.push([str]);
        MainClAry.push(str);
        ActionName.push("文字");
        ActionName_test.push("文字");
        ChanceArr.push("100%");
        ChanceLimitArr.push(true);
        WordArr.push(str_);

        let now_time = (new Date()).valueOf();
        let time_interval = now_time - timestamp; //间隔 单位毫秒
        dsqAry.push([time_interval]);
        timestamp = now_time;
        MainDsqAry.push(dsqAry);//间隔时间
        setTimeout(()=>{
            setText(str);
            word_.word_.attr("visibility","gone");
            win.setTouchable(true);
            word_.setPosition(-500,0);
            wordExpend = false;
        },300);
    });
});

let isMove = false; //滑动判定
let downX, downY //按下时的坐标
let upX, upY //松开时的坐标
win.img.setOnTouchListener(new android.view.View.OnTouchListener((view, event) => {
    try {
        let W = view.getWidth();
        let H = view.getHeight();
        let PC = event.getPointerCount();

        switch (event.getActionMasked()) {
            case event.ACTION_MOVE:
                // log("ACTION_MOVE");

                isMove = true;
                for (let i = 0; i < PC; i++) {
                    let id = event.getPointerId(i);
                    let X = event.getX(i);
                    let Y = event.getY(i);
                    TouchPointCurrent[i][0] = X;
                    TouchPointCurrent[i][1] = Y;
                };

                break;
            case event.ACTION_CANCEL:
                // log("CANCEL");
                kg = false;
                jishi = 0;

                TouchPointStart = new Array;
                TouchPointCurrent = new Array;
                TouchPointRecord = new Array;

                break;
            case event.ACTION_OUTSIDE:
                // log("OUTSIDE");

                break;
            default:
                let I = Math.floor(event.getAction() / 256);
                let ID = event.getPointerId(I);
                let X = event.getX(I);
                let Y = event.getY(I);
                let RX = event.getRawX();
                let RY = event.getRawY();
                let touch_click = true;//正常点击
                // log("default:" + 'X:' + X + 'Y:' + Y);
                switch (event.getActionMasked()) {
                    case event.ACTION_DOWN:

                        let now_time = (new Date()).valueOf();
                        let time_interval = now_time - timestamp; //间隔 单位毫秒
                        dsqAry.push([time_interval]);
                        timestamp = now_time;

                        downX = event.getRawX();
                        downY = event.getRawY();

                        vrx = RX - X, vry = RY - Y;
                        kg = true;
                        TouchPointRecord.splice(I, 0, [0, 1, [Math.floor(X + vrx), Math.floor(Y + vry)]]);
                        TouchPointStart.splice(I, 0, [X, Y]);
                        TouchPointCurrent.splice(I, 0, [X, Y]);
                        isMove = true;

                        break;
                    case event.ACTION_UP:

                        upX = event.getRawX();
                        upY = event.getRawY();
                        // 饿->吃->渴->喝-------
                        // ↑                   ↓
                        // |------------------ |
                        kg = false;
                        jishi = 0;
                        // log("TouchPointRecord[I]:" + TouchPointRecord[I]);
                        gesturesAry.push(TouchPointRecord[I]);
                        MainGesturesAry.push(gesturesAry);
                        // log("滑动距离X："+Math.abs(parseInt(upX) - parseInt(downX)));
                        // log("滑动距离Y："+Math.abs(parseInt(upY) - parseInt(downY)));
                        //是否是滑动
                        if (isMove) {

                            if ((Math.abs(parseInt(upX) - parseInt(downX)) >= 100) || (Math.abs(parseInt(upY) - parseInt(downY)) >= 100)) {
                                toastLog("滑动操作");
                                ActionName.push("滑动");
                                ActionName_test.push("滑动");
                                touch_click = false;
                                resAry.push(TouchPointRecord[I]);
                                clAry.push([parseInt(downX), parseInt(downY), parseInt(RX), parseInt(RY)]);
                            } else {
                                log("正常点击1");
                                touch_click = true;
                                 resAry.push(common.getRes(parseInt(RX), parseInt(RY)));
                                clAry.push([parseInt(upX), parseInt(upY)]);
                            }
                        } else {
                            log("正常点击");
                            touch_click = true;
                             resAry.push(common.getRes(parseInt(RX), parseInt(RY)));

                            clAry.push([parseInt(upX), parseInt(upY)]);
                        }


                        if (touch_click) {
                            ActionName.push("点击");
                            ActionName_test.push("点击");

                            if(lz_mode == 'accurate'){
                                let click_ = common.getRes(RX,RY);
                                resAry.push(click_);
                                currentPkg = click_.packageName;
                                nowPkg = currentPkg;
                                currentAppName = getAppName(currentPkg);
                            }
                            // resAry.push({'节点':[parseInt(upX),parseInt(upY)]});
                        }
                        WordArr.push('');
                        ChanceArr.push("100%");
                        ChanceLimitArr.push(true);
                        MainResAry.push(resAry);
                        MainClAry.push(clAry);
                        MainDsqAry.push(dsqAry);



                        gesturesAry = new Array;
                        resAry = new Array;
                        clAry = new Array;
                        dsqAry = new Array;


                        TouchPointStart = new Array;
                        TouchPointCurrent = new Array;
                        TouchPointRecord = new Array;

                        threads.start(function () {
                            ui.run(() => {
                                win.setTouchable(false);
                                win.setSize(1, 1);
                            });
                            // log(MainGesturesAry);
                            sleep(250);
                            try {
                                toastLog("响应中...");
                                gestures.apply(null, MainGesturesAry[MainGesturesAry.length - 1]);
                                currentPkg = currentPackage();
                                nowPkg = currentPkg;
                                currentAppName = getAppName(currentPkg);
                            } catch (e) {
                                log(getError(e));
                                MainGesturesAry.pop();
                                MainResAry.pop();
                                MainClAry.pop();
                                MainDsqAry.pop();
                                ActionName.pop();
                                ChanceArr.pop();
                                ChanceLimitArr.pop();
                                WordArr.pop();
                                ActionName_test.pop();

                                af.Refresh(reDraw);
                                toastLog("请规范操作，该次操作已撤回，请重新录制");
                            }

                            sleep(250);
                            ui.run(() => {
                                win.setTouchable(true);
                                win.setSize(W, H);
                                win_.actions.setText((parseInt(win_.actions.text())+1).toLocaleString());
                            });
                        });

                        isMove = false;
                        break;
                    case event.ACTION_POINTER_DOWN:
                        // log("POINTER_DOWN");
                        TouchPointRecord.splice(I, 0, [jishi * Ts, 1, [Math.floor(X + vrx), Math.floor(Y + vry)]]);
                        TouchPointStart.splice(I, 0, [X, Y]);
                        TouchPointCurrent.splice(I, 0, [X, Y]);
                        break;
                    case event.ACTION_POINTER_UP:
                        // log("POINTER_UP:" + TouchPointRecord[I]);
                        gesturesAry.push(TouchPointRecord[I]);

                        TouchPointStart.splice(I, 1);
                        TouchPointCurrent.splice(I, 1);
                        TouchPointRecord.splice(I, 1);

                        break;
                };
        };
    } catch (e) {
        log(getError(e));
    };
    af.Refresh(reDraw);
    return true;
}));


/**
 * 异常捕获格式化输出
 * @param {*} e
 * @returns
 */
function getError(e){
    return files.getNameWithoutExtension(e.fileName)+':line:' + e.lineNumber + ':'+e.message+';';
}


function 绘布(view) {
    if (view.accessibilityClassName != "android.widget.ImageView") {
        //throw "我报错";
    };
    this.width = view.getWidth();
    this.height = view.getHeight();
    this.bitmap = android.graphics.Bitmap.createBitmap(this.width || 1000, this.height || 1000, android.graphics.Bitmap.Config.ARGB_8888);
    this.canvas = new Canvas(this.bitmap);
    this.matrix = new android.graphics.Matrix();
    //threads.start(new java.lang.Runnable(() => {}));
    this.isOK = () => {
        this.width = view.getWidth();
        this.height = view.getHeight();
        this.bitmap = android.graphics.Bitmap.createBitmap(this.width || 1000, this.height || 1000, android.graphics.Bitmap.Config.ARGB_8888);
        this.canvas = new Canvas(this.bitmap);
        if (this.width <= 0 || this.height <= 0) {
            return false;
        };
        return true;
    };

    this.Draw = function () { };
    this.setDraw = function (fun) {
        if (typeof fun == "function") {
            this.Draw = fun;
        };
    };

    this.Refresh = (fun) => {
        try {
            this.bitmap.eraseColor(0);
            this.canvas.setMatrix(this.matrix);
            if (typeof fun == "function") {
                fun(this.canvas);
            } else {
                this.Draw(this.canvas);
            };
            ui.run(() => {
                view.setImageBitmap(this.bitmap);
            });
        } catch (e) {
            toastLog(getError(e));
        };
    };


};


function 悬浮控制(window, windowid, ar) {
    this.Orientation = context.resources.configuration.orientation;
    this.Width = this.Orientation == 1 ? device.width : device.height;
    this.Height = this.Orientation == 2 ? device.width : device.height;
    this.isAutoIntScreen = true;
    this.Click = function () { };
    this.Move = function () { };
    this.LongClick = function () { };
    this.setClick = (fun) => {
        fun = fun || function () { };
        this.Click = fun;
    };
    this.setMove = (fun) => {
        fun = fun || function () { };
        this.Move = fun;
    };
    this.setPosition = function(xy_arr){
        window.setPosition(xy_arr[0],xy_arr[1]);
    }
    this.setLongClick = (fun, ji) => {
        fun = fun || function () { };
        this.LongClick = fun;
        if (parseInt(ji)) {
            this.Tjitime = parseInt(ji) / 50;
        };
    };
    setInterval(() => {
        if (context.resources.configuration.orientation != this.Orientation) {
            this.Orientation = context.resources.configuration.orientation;
            this.Width = this.Orientation == 1 ? device.width : device.height;
            this.Height = this.Orientation == 2 ? device.width : device.height;
            let xy = this.windowGXY(window.getX(), window.getY(), this.G(window));
            this.windowyidong([
                [window.getX(), window.getY()],
                [xy.x, xy.y]
            ]);
        };
    }, 100);
    this.TX = 0;
    this.TY = 0;
    this.Tx = 0;
    this.Ty = 0;
    this.Tyidong = false;
    this.Tkeep = false;
    this.Tjitime = 12;
    this.Ttime = 0;
    setInterval(() => {
        if (this.Tkeep) {
            this.Ttime++;
            if (!this.Tyidong && this.Ttime > this.Tjitime) {
                //非移动且按下时长超过1秒判断为长按
                this.Tkeep = false;
                this.Ttime = 0;
                this.LongClick();
            };
        };
    }, 50);
    if (windowid) {
        windowid.setOnTouchListener(new android.view.View.OnTouchListener((view, event) => {
            this.Move(view, event);

            switch (event.getAction()) {
                case event.ACTION_DOWN:
                    log("按下,开启计时")
                    this.Tx = event.getRawX();
                    this.Ty = event.getRawY();
                    this.TX = window.getX();
                    this.TY = window.getY();
                    this.Tkeep = true; //按下,开启计时
                    break;
                case event.ACTION_MOVE:

                    let sx = event.getRawX() - this.Tx;
                    let sy = event.getRawY() - this.Ty;
                    if (!this.Tyidong && this.Tkeep && this.weiyi(sx, sy) >= 10) {
                        this.Tyidong = true;
                    };
                    if (this.Tyidong && this.Tkeep) {
                        window.setPosition(this.TX + sx, this.TY + sy);
                        word_.setPosition(win_.getX()+win_.width,win_.getY());
                    };
                    break;
                case event.ACTION_UP:
                    if (!this.Tyidong && this.Tkeep && this.Ttime < 7) {
                        this.Click();
                    };
                    this.Tkeep = false;
                    this.Ttime = 0;
                    if (this.Tyidong) {
                        if (this.isAutoIntScreen) {
                            threads.start(new java.lang.Runnable(() => {
                                this.windowyidong(this.IntScreen());
                            }));
                        } else {
                            threads.start(new java.lang.Runnable(() => {
                                this.windowyidong(this.ViewIntScreen());
                            }));

                        };

                        this.Tyidong = false;
                    };
                    break;
            };
            return true;
        }));
    };
    this.G = (win, view) => {
        //返回悬浮窗的坐标范围。
        let K = 36, //悬浮窗的隐形边矩
            H = 66; //手机通知栏的高度
        let ary;
        if (!ar) {
            if (view) {
                ary = [
                    [-view.getX(), -view.getY()],
                    [this.Width - (view.getX() + view.getWidth()), this.Height - (view.getY() + view.getHeight()) - H - K]
                ];

            } else {
                ary = [
                    [0, 0],
                    [this.Width - win.getWidth() + K * 2, this.Height - win.getHeight() - H + K * 2]
                ];
            }
        } else {
            if (view) {
                ary = [
                    [-view.getX(), H - view.getY()],
                    [this.Width - (view.getX() + view.getWidth()), this.Height - (view.getY() + view.getHeight())]
                ];

            } else {
                ary = [
                    [0, H],
                    [this.Width - win.getWidth(), this.Height - win.getHeight()]
                ];
            }
        };
        return ary;
    };
    this.weiyi = function () { //平方和开方
        let num = 0;
        for (let i = 0; i < arguments.length; i++) {
            num += arguments[i] * arguments[i];
        };
        return Math.round(Math.sqrt(num) * 1000) / 1000
    };
    this.windowGXY = function (x, y, k) {
        //修正坐标的所在范围。如果坐标超出了范围，则修正回来。
        x = (k[0][0] < x && x < k[1][0]) ? x : (k[0][0] < x ? k[1][0] : k[0][0]);
        y = (k[0][1] < y && y < k[1][1]) ? y : (k[0][1] < y ? k[1][1] : k[0][1]);
        return {
            x: x,
            y: y
        };
    };
    this.windowyidong = (A, s, w) => {
        //移动悬浮窗的动画效果。
        w = w || window;
        s = s || 10;
        let sx = A[1][0] - A[0][0],
            sy = A[1][1] - A[0][1];
        let sd = this.weiyi(sx, sy) / s;
        let X = sx / sd,
            Y = sy / sd;
        let x = 0,
            y = 0;
        for (let i = 0; i < sd; i++) {
            x += X;
            y += Y;
            sleep(1);
            w.setPosition(A[0][0] + x, A[0][1] + y);
            word_.setPosition(win_.getX()+win_.width,win_.getY()+y);
        };
        w.setPosition(A[1][0], A[1][1]);
        word_.setPosition(A[1][0]+win_.width,A[1][1]);
    };
    this.OutScreen = () => {
        //算出最短的距离到达屏幕之外。
        let F = this.G(window);
        let x = window.getX(),
            y = window.getY();
        let sx = window.getX() + window.getWidth() / 2,
            sy = window.getY() + window.getHeight() / 2 + 66;
        let cx = Math.abs(sx < (this.Width - sx) ? sx : (this.Width - sx)) < Math.abs(sy < (this.Height - sy) ? sy : (this.Height - sy)) ? (sx < this.Width / 2 ? (F[0][0] - window.getWidth()) : (F[1][0] + window.getWidth())) : x,
            cy = Math.abs(sx < (this.Width - sx) ? sx : (this.Width - sx)) < Math.abs(sy < (this.Height - sy) ? sy : (this.Height - sy)) ? y : (sy < this.Height / 2 ? (F[0][1] - window.getHeight()) : (F[1][1] + window.getHeight()));
        return [
            [x, y],
            [cx, cy]
        ];
    };
    this.toScreenEdge = (d) => {
        //返回到屏幕边缘的坐标。d为浮点数0.1~1之间。
        d = d || 0;
        let F = this.G(window);
        let x = window.getX(),
            y = window.getY();
        let sw = window.getWidth() * d;
        let sx = window.getX() + window.getWidth() / 2,
            sy = window.getY() + window.getHeight() / 2 + 66;
        let cx = sx < (this.Width - sx) ? -sw : (this.Width + sw - window.getWidth() + 72);
        return [
            [x, y],
            [cx, y]
        ];
    };
    this.centerXY = (F) => {
        //返回距离中心位置的一个方形两个坐标。
        let w = window.getWidth();
        let h = window.getHeight();
        return [
            [F[0] + w / 2, F[1] + h / 2],
            [F[0] - w / 2, F[1] - h / 2]
        ];
    };
    this.IntScreen = () => {
        //当悬浮超出屏幕之外之后进入的坐标。
        let A = this.windowGXY(window.getX(), window.getY(), this.G(window));
        return [
            [window.getX(), window.getY()],
            [A.x, A.y]
        ];
    };
    this.ViewIntScreen = () => {
        //当悬浮超出屏幕之外之后进入的坐标。
        let A = this.windowGXY(window.getX(), window.getY(), this.G(window, windowid));
        return [
            [window.getX(), window.getY()],
            [A.x, A.y]
        ];
    };
    threads.start(new java.lang.Runnable(() => {
        this.windowyidong(this.IntScreen());
    }));
};
function reDraw(canvas) {
    //canvas.drawARGB(255, 127, 127, 127);
    let w = canvas.getWidth();
    let h = canvas.getHeight();
    let AX = w / 2;
    let AY = h / 2;

    paint.setStyle(Paint.Style.STROKE);
//    canvas.drawText("当前模式:"+now_mode+'已录制'+String(MainGesturesAry.length + "个动作"), 10, textSize, paint);

    if (TouchPointStart.length) {

        for (let i = 0; i < TouchPointStart.length; i++) {
            try {
                let X = TouchPointStart[i][0];
                let Y = TouchPointStart[i][1];
                let x = TouchPointCurrent[i][0];
                let y = TouchPointCurrent[i][1];
                X = X || 0;
                Y = Y || 0;
                x = x || 0;
                y = y || 0;
                let a = X - (x - X);
                let b = Y - (y - Y);
                //let rect = new android.graphics.RectF(X, Y, x, y);
                //canvas.drawRect(rect, paint);
                //let rect2 = new android.graphics.RectF(X, Y, a, b);
                //canvas.drawRect(rect2, paint);
                //let rect3 = new android.graphics.RectF(x, y, a, b);
                //canvas.drawRect(rect3, paint);
                //canvas.drawLine(X, Y, x, y, paint);
                //canvas.drawLine(X, Y, a, b, paint);
                canvas.drawText(String("A"), X, Y, paint);
                canvas.drawText(String("B"), x, y, paint);
                canvas.drawCircle(X, Y, 10, paint);
                canvas.drawCircle(x, y, 10, paint);
                //canvas.drawCircle(a, b, 10, paint);
            } catch (e) { log(getError(e)) };
        };
        for (let ii = 0; ii < TouchPointRecord.length; ii++) {
            let ge = TouchPointRecord[ii];
            canvas.drawText(String("*"), ge[0] / 10 * ii + jishi * Ts / 25, textSize * (ii + 2), paint)
            for (let i = 2; i < ge.length - 1; i++) {

                let X = ge[i][0] - vrx;
                let Y = ge[i][1] - vry;
                let x = ge[i + 1][0] - vrx;
                let y = ge[i + 1][1] - vry;
                X = X || 0;
                Y = Y || 0;
                x = x || 0;
                y = y || 0;
                //let a = X - (x - X);
                //let b = Y - (y - Y);
                //let rect = new android.graphics.RectF(X, Y, x, y);
                //canvas.drawRect(rect, paint);
                //let rect2 = new android.graphics.RectF(X, Y, a, b);
                //canvas.drawRect(rect2, paint);
                //let rect3 = new android.graphics.RectF(x, y, a, b);
                //canvas.drawRect(rect3, paint);
                canvas.drawLine(X, Y, x, y, paint);
                //canvas.drawLine(X, Y, a, b, paint);
                //canvas.drawText(String("A"), X, Y, paint)
                //canvas.drawText(String("B"), x, y, paint);
                //canvas.drawCircle(X, Y, 10, paint);
                //canvas.drawCircle(x, y, 10, paint);
                //canvas.drawCircle(a, b, 10, paint);
            };
        };
    };

};

function 反色(color) {
    return (-1 - colors.argb(0, colors.red(color), colors.green(color), colors.blue(color)));
};

function toJavaArray(type, ary) {
    //let Ary = java.lang.reflect.Array.newInstance(		java.lang.Float.TYPE, 4);
    let Ary = util.java.array(type, ary.length);
    for (let i in ary) {
        Ary[i] = ary[i];
    };
    return Ary;
};

function SolvePos(a, b, r, k, c) {
    let a1 = k * k + 1;
    let b1 = 2 * k * (c - b) - 2 * a;
    let c1 = a * a + (c - b) * (c - b) - r * r;
    let delta = b1 * b1 - 4 * a1 * c1;
    let result = [];
    if (delta == 0) {
        let x0 = Math.sqrt(delta);
        let x1 = -b1 / (2 * a1);
        let y1 = k * x1 + c;
        result.push(x1, y1);
    } else if (delta > 0) {
        let x0 = Math.sqrt(delta);
        let x1 = (-b1 - x0) / (2 * a1);
        let y1 = k * x1 + c;
        result.push(x1, y1);
        let x2 = (-b1 + x0) / (2 * a1);
        let y2 = k * x2 + c;
        result.push(x2, y2);
    }
    return result;
};

function weiyi(ary) {
    let sum = 0;
    for (let i = 0; i < ary.length; i++) {
        sum += Math.pow(ary[i], 2);
    };
    return Math.sqrt(sum);
};

function kdfx(Y) {
    let x = Math.cos(Y % 360 / 360 * 2 * Math.PI);
    let y = Math.sin(Y % 360 / 360 * 2 * Math.PI);
    return {
        x: x,
        y: y
    };
};

function ydfx(obj) {
    let ary = getsd(1, [obj.x, obj.y]);
    let x = ary[0],
        y = ary[1];
    let Y = Math.asin(y) / (2 * Math.PI) * 360;
    if (x < 0) {
        Y = 180 - Y;
    };
    return Y;
};

function getsd(s, ary) {
    let sum = weiyi(ary);
    let S = s / sum;
    for (let i = 0; i < ary.length; i++) {
        ary[i] = ary[i] * S;
    };
    return ary;
};

function XYTOAB(x, y, x1, y1) {
    let A = (y1 - y) / (x1 - x);
    let B = y - A * x;
    return [A, B];
};
//输入对话弹框 ui
function inputFloaty() {
        win.setTouchable(false);
        rawInput("请输入要发送的文字", "").then(win_input => {
            if (win_input) {
                let str = win_input;
                if (str) {
                        let str_ = str.split("@");
                        str = str_[random(0,str_.length-1)];
                        // log(MainGesturesAry);
                        // gesturesAry.push(str);
                        MainGesturesAry.push(str);
                        MainResAry.push([str]);
                        MainClAry.push(str);
                        ActionName.push("文字");
                        ActionName_test.push("文字");
                        ChanceArr.push("100%");
                        ChanceLimitArr.push(true);
                        WordArr.push(str_);

                        let now_time = (new Date()).valueOf();
                        let time_interval = now_time - timestamp; //间隔 单位毫秒
                        dsqAry.push([time_interval]);
                        timestamp = now_time;
                        MainDsqAry.push(dsqAry);//间隔时间
                        setTimeout(()=>{
                            setText(str);
                            win.setTouchable(true);
                        },500);
                        // log('459MainGesturesAry:'+MainGesturesAry);

                } else {
                    toastLog("未输入文字");
                }

            }
            win.setTouchable(true);
        });



}

