let common = {};
let show_ary = ["id", "text", "desc", "clickable", "className", "bounds","visibleToUser", "scrollable", "depth","getChildCount","getActionList","hashCode","getWindow","indexInParent"];
let storage = storages.create('Hodgepodge');
/**
 * 判断是否是数组
 * @param {*} o
 */
common.isArrayFn = function (o) {

    return Object.prototype.toString.call(o) === '[object Array]';

}

/**
 * 量数组大小相差平均数(元素位数必须相同)
 * @param {*} arr1
 * @param {*} arr2
 */
common.arrRegion = function (arr1, arr2) {

    let result = 0;
    for (let index = 0; index < arr1.length; index++) {
        let item2 = arr2[index];
        let item1 = arr1[index];
        result = result + Math.abs(item1 - item2);
    }
    return result / arr1.length;

}


common.fnToStr = function (fn) {

    return fn.toString().split('\n').slice(1, -1).join('\n') + '\n';

}

/**
 * 取得随机一个图标
 */
common.getDrawable = function () {
    let icons =
        [
            'ic_3d_rotation_black_48dp', 'ic_accessibility_black_48dp', 'ic_accessible_black_48dp', 'ic_account_balance_black_48dp', 'ic_account_balance_wallet_black_48dp', 'ic_account_box_black_48dp', 'ic_account_circle_black_48dp', 'ic_add_shopping_cart_black_48dp', 'ic_alarm_add_black_48dp', 'ic_alarm_black_48dp', 'ic_alarm_off_black_48dp', 'ic_alarm_on_black_48dp', 'ic_all_out_black_48dp', 'ic_android_black_48dp', 'ic_announcement_black_48dp', 'ic_aspect_ratio_black_48dp', 'ic_assessment_black_48dp', 'ic_assignment_black_48dp', 'ic_assignment_ind_black_48dp', 'ic_assignment_late_black_48dp', 'ic_assignment_returned_black_48dp', 'ic_assignment_return_black_48dp', 'ic_assignment_turned_in_black_48dp', 'ic_autorenew_black_48dp', 'ic_backup_black_48dp', 'ic_bookmark_black_48dp', 'ic_bookmark_border_black_48dp', 'ic_book_black_48dp', 'ic_bug_report_black_48dp', 'ic_build_black_48dp', 'ic_cached_black_48dp', 'ic_camera_enhance_black_48dp', 'ic_card_giftcard_black_48dp', 'ic_card_membership_black_48dp', 'ic_card_travel_black_48dp', 'ic_change_history_black_48dp', 'ic_check_circle_black_48dp', 'ic_chrome_reader_mode_black_48dp', 'ic_class_black_48dp', 'ic_code_black_48dp', 'ic_compare_arrows_black_48dp', 'ic_copyright_black_48dp', 'ic_credit_card_black_48dp', 'ic_dashboard_black_48dp', 'ic_date_range_black_48dp', 'ic_delete_black_48dp', 'ic_delete_forever_black_48dp', 'ic_description_black_48dp', 'ic_dns_black_48dp', 'ic_done_all_black_48dp', 'ic_done_black_48dp', 'ic_donut_large_black_48dp', 'ic_donut_small_black_48dp', 'ic_eject_black_48dp', 'ic_euro_symbol_black_48dp', 'ic_event_black_48dp', 'ic_event_seat_black_48dp', 'ic_exit_to_app_black_48dp', 'ic_explore_black_48dp', 'ic_extension_black_48dp', 'ic_face_black_48dp', 'ic_favorite_black_48dp', 'ic_favorite_border_black_48dp', 'ic_feedback_black_48dp', 'ic_find_in_page_black_48dp', 'ic_find_replace_black_48dp', 'ic_fingerprint_black_48dp', 'ic_flight_land_black_48dp', 'ic_flight_takeoff_black_48dp', 'ic_flip_to_back_black_48dp', 'ic_flip_to_front_black_48dp', 'ic_gavel_black_48dp', 'ic_get_app_black_48dp', 'ic_gif_black_48dp', 'ic_grade_black_48dp', 'ic_group_work_black_48dp', 'ic_g_translate_black_48dp', 'ic_help_black_48dp', 'ic_help_outline_black_48dp', 'ic_highlight_off_black_48dp', 'ic_history_black_48dp', 'ic_home_black_48dp', 'ic_hourglass_empty_black_48dp', 'ic_hourglass_full_black_48dp', 'ic_https_black_48dp', 'ic_http_black_48dp', 'ic_important_devices_black_48dp', 'ic_info_black_48dp', 'ic_info_outline_black_48dp', 'ic_input_black_48dp', 'ic_invert_colors_black_48dp', 'ic_label_black_48dp', 'ic_label_outline_black_48dp', 'ic_language_black_48dp', 'ic_launch_black_48dp', 'ic_lightbulb_outline_black_48dp', 'ic_line_style_black_48dp', 'ic_line_weight_black_48dp', 'ic_list_black_48dp', 'ic_lock_black_48dp', 'ic_lock_open_black_48dp', 'ic_lock_outline_black_48dp', 'ic_loyalty_black_48dp', 'ic_markunread_mailbox_black_48dp', 'ic_motorcycle_black_48dp', 'ic_note_add_black_48dp', 'ic_offline_pin_black_48dp', 'ic_opacity_black_48dp', 'ic_open_in_browser_black_48dp', 'ic_open_in_new_black_48dp', 'ic_open_with_black_48dp', 'ic_pageview_black_48dp', 'ic_pan_tool_black_48dp', 'ic_payment_black_48dp', 'ic_perm_camera_mic_black_48dp', 'ic_perm_contact_calendar_black_48dp', 'ic_perm_data_setting_black_48dp', 'ic_perm_device_information_black_48dp', 'ic_perm_identity_black_48dp', 'ic_perm_media_black_48dp', 'ic_perm_phone_msg_black_48dp', 'ic_perm_scan_wifi_black_48dp', 'ic_pets_black_48dp', 'ic_picture_in_picture_alt_black_48dp', 'ic_picture_in_picture_black_48dp', 'ic_play_for_work_black_48dp', 'ic_polymer_black_48dp', 'ic_power_settings_new_black_48dp', 'ic_pregnant_woman_black_48dp', 'ic_print_black_48dp', 'ic_query_builder_black_48dp', 'ic_question_answer_black_48dp', 'ic_receipt_black_48dp', 'ic_record_voice_over_black_48dp', 'ic_redeem_black_48dp', 'ic_remove_shopping_cart_black_48dp', 'ic_reorder_black_48dp', 'ic_report_problem_black_48dp', 'ic_restore_black_48dp', 'ic_restore_page_black_48dp', 'ic_room_black_48dp', 'ic_rounded_corner_black_48dp', 'ic_rowing_black_48dp', 'ic_schedule_black_48dp', 'ic_search_black_48dp', 'ic_settings_applications_black_48dp', 'ic_settings_backup_restore_black_48dp', 'ic_settings_black_48dp', 'ic_settings_bluetooth_black_48dp', 'ic_settings_brightness_black_48dp', 'ic_settings_cell_black_48dp', 'ic_settings_ethernet_black_48dp', 'ic_settings_input_antenna_black_48dp', 'ic_settings_input_component_black_48dp', 'ic_settings_input_composite_black_48dp', 'ic_settings_input_hdmi_black_48dp', 'ic_settings_input_svideo_black_48dp', 'ic_settings_overscan_black_48dp', 'ic_settings_phone_black_48dp', 'ic_settings_power_black_48dp', 'ic_settings_remote_black_48dp', 'ic_settings_voice_black_48dp', 'ic_shopping_basket_black_48dp', 'ic_shopping_cart_black_48dp', 'ic_shop_black_48dp', 'ic_shop_two_black_48dp', 'ic_speaker_notes_black_48dp', 'ic_speaker_notes_off_black_48dp', 'ic_spellcheck_black_48dp', 'ic_stars_black_48dp', 'ic_store_black_48dp', 'ic_subject_black_48dp', 'ic_supervisor_account_black_48dp', 'ic_swap_horiz_black_48dp', 'ic_swap_vertical_circle_black_48dp', 'ic_swap_vert_black_48dp', 'ic_system_update_alt_black_48dp', 'ic_tab_black_48dp', 'ic_tab_unselected_black_48dp', 'ic_theaters_black_48dp', 'ic_thumbs_up_down_black_48dp', 'ic_thumb_down_black_48dp', 'ic_thumb_up_black_48dp', 'ic_timeline_black_48dp', 'ic_toc_black_48dp', 'ic_today_black_48dp', 'ic_toll_black_48dp', 'ic_touch_app_black_48dp', 'ic_track_changes_black_48dp', 'ic_translate_black_48dp', 'ic_trending_down_black_48dp', 'ic_trending_flat_black_48dp', 'ic_trending_up_black_48dp', 'ic_turned_in_black_48dp', 'ic_turned_in_not_black_48dp', 'ic_update_black_48dp', 'ic_verified_user_black_48dp', 'ic_view_agenda_black_48dp', 'ic_view_array_black_48dp', 'ic_view_carousel_black_48dp', 'ic_view_column_black_48dp', 'ic_view_day_black_48dp', 'ic_view_headline_black_48dp', 'ic_view_list_black_48dp', 'ic_view_module_black_48dp', 'ic_view_quilt_black_48dp', 'ic_view_stream_black_48dp', 'ic_view_week_black_48dp', 'ic_visibility_black_48dp', 'ic_visibility_off_black_48dp', 'ic_watch_later_black_48dp', 'ic_work_black_48dp', 'ic_youtube_searched_for_black_48dp', 'ic_zoom_in_black_48dp', 'ic_zoom_out_black_48dp', 'ic_add_alert_black_48dp', 'ic_error_black_48dp', 'ic_error_outline_black_48dp', 'ic_warning_black_48dp', 'ic_add_to_queue_black_48dp', 'ic_airplay_black_48dp', 'ic_album_black_48dp', 'ic_art_track_black_48dp', 'ic_av_timer_black_48dp', 'ic_branding_watermark_black_48dp', 'ic_call_to_action_black_48dp', 'ic_closed_caption_black_48dp', 'ic_equalizer_black_48dp', 'ic_explicit_black_48dp', 'ic_fast_forward_black_48dp', 'ic_fast_rewind_black_48dp', 'ic_featured_play_list_black_48dp', 'ic_featured_video_black_48dp', 'ic_fiber_dvr_black_48dp', 'ic_fiber_manual_record_black_48dp', 'ic_fiber_new_black_48dp', 'ic_fiber_pin_black_48dp', 'ic_fiber_smart_record_black_48dp', 'ic_forward_10_black_48dp', 'ic_forward_30_black_48dp', 'ic_forward_5_black_48dp', 'ic_games_black_48dp', 'ic_hd_black_48dp', 'ic_hearing_black_48dp', 'ic_high_quality_black_48dp', 'ic_library_add_black_48dp', 'ic_library_books_black_48dp', 'ic_library_music_black_48dp', 'ic_loop_black_48dp', 'ic_mic_black_48dp', 'ic_mic_none_black_48dp', 'ic_mic_off_black_48dp', 'ic_movie_black_48dp', 'ic_music_video_black_48dp', 'ic_new_releases_black_48dp', 'ic_note_black_48dp', 'ic_not_interested_black_48dp', 'ic_pause_black_48dp', 'ic_pause_circle_filled_black_48dp', 'ic_pause_circle_outline_black_48dp', 'ic_playlist_add_black_48dp', 'ic_playlist_add_check_black_48dp', 'ic_playlist_play_black_48dp', 'ic_play_arrow_black_48dp', 'ic_play_circle_filled_black_48dp', 'ic_play_circle_filled_white_black_48dp', 'ic_play_circle_outline_black_48dp', 'ic_queue_black_48dp', 'ic_queue_music_black_48dp', 'ic_queue_play_next_black_48dp', 'ic_radio_black_48dp', 'ic_recent_actors_black_48dp', 'ic_remove_from_queue_black_48dp', 'ic_repeat_black_48dp', 'ic_repeat_one_black_48dp', 'ic_replay_10_black_48dp', 'ic_replay_30_black_48dp', 'ic_replay_5_black_48dp', 'ic_replay_black_48dp', 'ic_shuffle_black_48dp', 'ic_skip_next_black_48dp', 'ic_skip_previous_black_48dp', 'ic_slow_motion_video_black_48dp', 'ic_snooze_black_48dp', 'ic_sort_by_alpha_black_48dp', 'ic_stop_black_48dp', 'ic_subscriptions_black_48dp', 'ic_subtitles_black_48dp', 'ic_surround_sound_black_48dp', 'ic_videocam_black_48dp', 'ic_videocam_off_black_48dp', 'ic_video_call_black_48dp', 'ic_video_label_black_48dp', 'ic_video_library_black_48dp', 'ic_volume_down_black_48dp', 'ic_volume_mute_black_48dp', 'ic_volume_off_black_48dp', 'ic_volume_up_black_48dp', 'ic_web_asset_black_48dp', 'ic_web_black_48dp', 'ic_business_black_48dp', 'ic_call_black_48dp', 'ic_call_end_black_48dp', 'ic_call_made_black_48dp', 'ic_call_merge_black_48dp', 'ic_call_missed_black_48dp', 'ic_call_missed_outgoing_black_48dp', 'ic_call_received_black_48dp', 'ic_call_split_black_48dp', 'ic_chat_black_48dp', 'ic_chat_bubble_black_48dp', 'ic_chat_bubble_outline_black_48dp', 'ic_clear_all_black_48dp', 'ic_comment_black_48dp', 'ic_contacts_black_48dp', 'ic_contact_mail_black_48dp', 'ic_contact_phone_black_48dp', 'ic_dialer_sip_black_48dp', 'ic_dialpad_black_48dp', 'ic_email_black_48dp', 'ic_forum_black_48dp', 'ic_import_contacts_black_48dp', 'ic_import_export_black_48dp', 'ic_invert_colors_off_black_48dp', 'ic_live_help_black_48dp', 'ic_location_off_black_48dp', 'ic_location_on_black_48dp', 'ic_mail_outline_black_48dp', 'ic_message_black_48dp', 'ic_no_sim_black_48dp', 'ic_phonelink_erase_black_48dp', 'ic_phonelink_lock_black_48dp', 'ic_phonelink_ring_black_48dp', 'ic_phonelink_setup_black_48dp', 'ic_phone_black_48dp', 'ic_portable_wifi_off_black_48dp', 'ic_present_to_all_black_48dp', 'ic_ring_volume_black_48dp', 'ic_rss_feed_black_48dp', 'ic_screen_share_black_48dp', 'ic_speaker_phone_black_48dp', 'ic_stay_current_landscape_black_48dp', 'ic_stay_current_portrait_black_48dp', 'ic_stay_primary_landscape_black_48dp',
            'ic_stay_primary_portrait_black_48dp', 'ic_stop_screen_share_black_48dp', 'ic_swap_calls_black_48dp', 'ic_textsms_black_48dp', 'ic_voicemail_black_48dp', 'ic_vpn_key_black_48dp', 'ic_add_black_48dp', 'ic_add_box_black_48dp', 'ic_add_circle_black_48dp', 'ic_add_circle_outline_black_48dp', 'ic_archive_black_48dp', 'ic_backspace_black_48dp', 'ic_block_black_48dp', 'ic_clear_black_48dp', 'ic_content_copy_black_48dp', 'ic_content_cut_black_48dp', 'ic_content_paste_black_48dp', 'ic_create_black_48dp', 'ic_delete_sweep_black_48dp', 'ic_drafts_black_48dp', 'ic_filter_list_black_48dp', 'ic_flag_black_48dp', 'ic_font_download_black_48dp', 'ic_forward_black_48dp', 'ic_gesture_black_48dp', 'ic_inbox_black_48dp', 'ic_link_black_48dp', 'ic_low_priority_black_48dp', 'ic_mail_black_48dp', 'ic_markunread_black_48dp', 'ic_move_to_inbox_black_48dp', 'ic_next_week_black_48dp', 'ic_redo_black_48dp', 'ic_remove_black_48dp', 'ic_remove_circle_black_48dp', 'ic_remove_circle_outline_black_48dp', 'ic_reply_all_black_48dp', 'ic_reply_black_48dp', 'ic_report_black_48dp', 'ic_save_black_48dp', 'ic_select_all_black_48dp', 'ic_send_black_48dp', 'ic_sort_black_48dp', 'ic_text_format_black_48dp', 'ic_unarchive_black_48dp', 'ic_undo_black_48dp', 'ic_weekend_black_48dp', 'ic_access_alarms_black_48dp', 'ic_access_alarm_black_48dp', 'ic_access_time_black_48dp', 'ic_add_alarm_black_48dp', 'ic_airplanemode_active_black_48dp', 'ic_airplanemode_inactive_black_48dp', 'ic_battery_20_black_48dp', 'ic_battery_30_black_48dp', 'ic_battery_50_black_48dp', 'ic_battery_60_black_48dp', 'ic_battery_80_black_48dp', 'ic_battery_90_black_48dp', 'ic_battery_alert_black_48dp', 'ic_battery_charging_20_black_48dp', 'ic_battery_charging_30_black_48dp', 'ic_battery_charging_50_black_48dp', 'ic_battery_charging_60_black_48dp', 'ic_battery_charging_80_black_48dp', 'ic_battery_charging_90_black_48dp', 'ic_battery_charging_full_black_48dp', 'ic_battery_full_black_48dp', 'ic_battery_std_black_48dp', 'ic_battery_unknown_black_48dp', 'ic_bluetooth_black_48dp', 'ic_bluetooth_connected_black_48dp', 'ic_bluetooth_disabled_black_48dp', 'ic_bluetooth_searching_black_48dp', 'ic_brightness_auto_black_48dp', 'ic_brightness_high_black_48dp', 'ic_brightness_low_black_48dp', 'ic_brightness_medium_black_48dp', 'ic_data_usage_black_48dp', 'ic_developer_mode_black_48dp', 'ic_devices_black_48dp', 'ic_dvr_black_48dp', 'ic_gps_fixed_black_48dp', 'ic_gps_not_fixed_black_48dp', 'ic_gps_off_black_48dp', 'ic_graphic_eq_black_48dp', 'ic_location_disabled_black_48dp', 'ic_location_searching_black_48dp', 'ic_network_cell_black_48dp', 'ic_network_wifi_black_48dp', 'ic_nfc_black_48dp', 'ic_screen_lock_landscape_black_48dp', 'ic_screen_lock_portrait_black_48dp', 'ic_screen_lock_rotation_black_48dp', 'ic_screen_rotation_black_48dp', 'ic_sd_storage_black_48dp', 'ic_settings_system_daydream_black_48dp', 'ic_signal_cellular_0_bar_black_48dp', 'ic_signal_cellular_1_bar_black_48dp', 'ic_signal_cellular_2_bar_black_48dp', 'ic_signal_cellular_3_bar_black_48dp', 'ic_signal_cellular_4_bar_black_48dp', 'ic_signal_cellular_connected_no_internet_0_bar_black_48dp', 'ic_signal_cellular_connected_no_internet_1_bar_black_48dp', 'ic_signal_cellular_connected_no_internet_2_bar_black_48dp', 'ic_signal_cellular_connected_no_internet_3_bar_black_48dp', 'ic_signal_cellular_connected_no_internet_4_bar_black_48dp', 'ic_signal_cellular_no_sim_black_48dp', 'ic_signal_cellular_null_black_48dp', 'ic_signal_cellular_off_black_48dp', 'ic_signal_wifi_0_bar_black_48dp', 'ic_signal_wifi_1_bar_black_48dp', 'ic_signal_wifi_1_bar_lock_black_48dp', 'ic_signal_wifi_2_bar_black_48dp', 'ic_signal_wifi_2_bar_lock_black_48dp', 'ic_signal_wifi_3_bar_black_48dp', 'ic_signal_wifi_3_bar_lock_black_48dp', 'ic_signal_wifi_4_bar_black_48dp', 'ic_signal_wifi_4_bar_lock_black_48dp', 'ic_signal_wifi_off_black_48dp', 'ic_storage_black_48dp', 'ic_usb_black_48dp', 'ic_wallpaper_black_48dp', 'ic_widgets_black_48dp', 'ic_wifi_lock_black_48dp', 'ic_wifi_tethering_black_48dp', 'ic_attach_file_black_48dp', 'ic_attach_money_black_48dp', 'ic_border_all_black_48dp', 'ic_border_bottom_black_48dp', 'ic_border_clear_black_48dp', 'ic_border_color_black_48dp', 'ic_border_horizontal_black_48dp', 'ic_border_inner_black_48dp', 'ic_border_left_black_48dp', 'ic_border_outer_black_48dp', 'ic_border_right_black_48dp', 'ic_border_style_black_48dp', 'ic_border_top_black_48dp', 'ic_border_vertical_black_48dp', 'ic_bubble_chart_black_48dp', 'ic_drag_handle_black_48dp', 'ic_format_align_center_black_48dp', 'ic_format_align_justify_black_48dp', 'ic_format_align_left_black_48dp', 'ic_format_align_right_black_48dp', 'ic_format_bold_black_48dp', 'ic_format_clear_black_48dp', 'ic_format_color_fill_black_48dp', 'ic_format_color_reset_black_48dp', 'ic_format_color_text_black_48dp', 'ic_format_indent_decrease_black_48dp', 'ic_format_indent_increase_black_48dp', 'ic_format_italic_black_48dp', 'ic_format_line_spacing_black_48dp', 'ic_format_list_bulleted_black_48dp', 'ic_format_list_numbered_black_48dp', 'ic_format_paint_black_48dp', 'ic_format_quote_black_48dp', 'ic_format_shapes_black_48dp', 'ic_format_size_black_48dp', 'ic_format_strikethrough_black_48dp', 'ic_format_textdirection_l_to_r_black_48dp', 'ic_format_textdirection_r_to_l_black_48dp', 'ic_format_underlined_black_48dp', 'ic_functions_black_48dp', 'ic_highlight_black_48dp', 'ic_insert_chart_black_48dp', 'ic_insert_comment_black_48dp', 'ic_insert_drive_file_black_48dp', 'ic_insert_emoticon_black_48dp', 'ic_insert_invitation_black_48dp', 'ic_insert_link_black_48dp', 'ic_insert_photo_black_48dp', 'ic_linear_scale_black_48dp', 'ic_merge_type_black_48dp', 'ic_mode_comment_black_48dp', 'ic_mode_edit_black_48dp', 'ic_monetization_on_black_48dp', 'ic_money_off_black_48dp', 'ic_multiline_chart_black_48dp', 'ic_pie_chart_black_48dp', 'ic_pie_chart_outlined_black_48dp', 'ic_publish_black_48dp', 'ic_short_text_black_48dp', 'ic_show_chart_black_48dp', 'ic_space_bar_black_48dp', 'ic_strikethrough_s_black_48dp', 'ic_text_fields_black_48dp', 'ic_title_black_48dp', 'ic_vertical_align_bottom_black_48dp', 'ic_vertical_align_center_black_48dp', 'ic_vertical_align_top_black_48dp', 'ic_wrap_text_black_48dp', 'ic_attachment_black_48dp', 'ic_cloud_black_48dp', 'ic_cloud_circle_black_48dp', 'ic_cloud_done_black_48dp', 'ic_cloud_download_black_48dp', 'ic_cloud_off_black_48dp', 'ic_cloud_queue_black_48dp', 'ic_cloud_upload_black_48dp', 'ic_create_new_folder_black_48dp', 'ic_file_download_black_48dp', 'ic_file_upload_black_48dp', 'ic_folder_black_48dp', 'ic_folder_open_black_48dp', 'ic_folder_shared_black_48dp', 'ic_cast_black_48dp', 'ic_cast_connected_black_48dp', 'ic_computer_black_48dp', 'ic_desktop_mac_black_48dp', 'ic_desktop_windows_black_48dp', 'ic_developer_board_black_48dp', 'ic_devices_other_black_48dp', 'ic_device_hub_black_48dp', 'ic_dock_black_48dp', 'ic_gamepad_black_48dp', 'ic_headset_black_48dp', 'ic_headset_mic_black_48dp', 'ic_keyboard_arrow_down_black_48dp', 'ic_keyboard_arrow_left_black_48dp', 'ic_keyboard_arrow_right_black_48dp', 'ic_keyboard_arrow_up_black_48dp', 'ic_keyboard_backspace_black_48dp', 'ic_keyboard_black_48dp', 'ic_keyboard_capslock_black_48dp', 'ic_keyboard_hide_black_48dp', 'ic_keyboard_return_black_48dp', 'ic_keyboard_tab_black_48dp', 'ic_keyboard_voice_black_48dp', 'ic_laptop_black_48dp', 'ic_laptop_chromebook_black_48dp', 'ic_laptop_mac_black_48dp', 'ic_laptop_windows_black_48dp', 'ic_memory_black_48dp', 'ic_mouse_black_48dp', 'ic_phonelink_black_48dp', 'ic_phonelink_off_black_48dp', 'ic_phone_android_black_48dp', 'ic_phone_iphone_black_48dp', 'ic_power_input_black_48dp', 'ic_router_black_48dp', 'ic_scanner_black_48dp', 'ic_security_black_48dp', 'ic_sim_card_black_48dp', 'ic_smartphone_black_48dp', 'ic_speaker_black_48dp', 'ic_speaker_group_black_48dp', 'ic_tablet_android_black_48dp', 'ic_tablet_black_48dp', 'ic_tablet_mac_black_48dp', 'ic_toys_black_48dp', 'ic_tv_black_48dp', 'ic_videogame_asset_black_48dp', 'ic_watch_black_48dp', 'ic_add_a_photo_black_48dp', 'ic_add_to_photos_black_48dp', 'ic_adjust_black_48dp', 'ic_assistant_black_48dp', 'ic_assistant_photo_black_48dp', 'ic_audiotrack_black_48dp', 'ic_blur_circular_black_48dp', 'ic_blur_linear_black_48dp', 'ic_blur_off_black_48dp', 'ic_blur_on_black_48dp', 'ic_brightness_1_black_48dp', 'ic_brightness_2_black_48dp', 'ic_brightness_3_black_48dp', 'ic_brightness_4_black_48dp', 'ic_brightness_5_black_48dp', 'ic_brightness_6_black_48dp', 'ic_brightness_7_black_48dp', 'ic_broken_image_black_48dp', 'ic_brush_black_48dp', 'ic_burst_mode_black_48dp', 'ic_camera_alt_black_48dp', 'ic_camera_black_48dp', 'ic_camera_front_black_48dp', 'ic_camera_rear_black_48dp', 'ic_camera_roll_black_48dp', 'ic_center_focus_strong_black_48dp', 'ic_center_focus_weak_black_48dp', 'ic_collections_black_48dp', 'ic_collections_bookmark_black_48dp', 'ic_colorize_black_48dp', 'ic_color_lens_black_48dp', 'ic_compare_black_48dp', 'ic_control_point_black_48dp', 'ic_control_point_duplicate_black_48dp', 'ic_crop_16_9_black_48dp', 'ic_crop_3_2_black_48dp', 'ic_crop_5_4_black_48dp', 'ic_crop_7_5_black_48dp', 'ic_crop_black_48dp', 'ic_crop_din_black_48dp', 'ic_crop_free_black_48dp', 'ic_crop_landscape_black_48dp', 'ic_crop_original_black_48dp', 'ic_crop_portrait_black_48dp', 'ic_crop_rotate_black_48dp', 'ic_crop_square_black_48dp', 'ic_dehaze_black_48dp', 'ic_details_black_48dp', 'ic_edit_black_48dp', 'ic_exposure_black_48dp', 'ic_exposure_neg_1_black_48dp', 'ic_exposure_neg_2_black_48dp', 'ic_exposure_plus_1_black_48dp', 'ic_exposure_plus_2_black_48dp', 'ic_exposure_zero_black_48dp', 'ic_filter_1_black_48dp', 'ic_filter_2_black_48dp', 'ic_filter_3_black_48dp', 'ic_filter_4_black_48dp', 'ic_filter_5_black_48dp', 'ic_filter_6_black_48dp', 'ic_filter_7_black_48dp', 'ic_filter_8_black_48dp', 'ic_filter_9_black_48dp', 'ic_filter_9_plus_black_48dp', 'ic_filter_black_48dp', 'ic_filter_b_and_w_black_48dp', 'ic_filter_center_focus_black_48dp', 'ic_filter_drama_black_48dp', 'ic_filter_frames_black_48dp',
            'ic_filter_hdr_black_48dp', 'ic_filter_none_black_48dp', 'ic_filter_tilt_shift_black_48dp', 'ic_filter_vintage_black_48dp', 'ic_flare_black_48dp', 'ic_flash_auto_black_48dp', 'ic_flash_off_black_48dp', 'ic_flash_on_black_48dp', 'ic_flip_black_48dp', 'ic_gradient_black_48dp', 'ic_grain_black_48dp', 'ic_grid_off_black_48dp', 'ic_grid_on_black_48dp', 'ic_hdr_off_black_48dp', 'ic_hdr_on_black_48dp', 'ic_hdr_strong_black_48dp', 'ic_hdr_weak_black_48dp', 'ic_healing_black_48dp', 'ic_image_aspect_ratio_black_48dp', 'ic_image_black_48dp', 'ic_iso_black_48dp', 'ic_landscape_black_48dp', 'ic_leak_add_black_48dp', 'ic_leak_remove_black_48dp', 'ic_lens_black_48dp', 'ic_linked_camera_black_48dp', 'ic_looks_3_black_48dp', 'ic_looks_4_black_48dp', 'ic_looks_5_black_48dp', 'ic_looks_6_black_48dp', 'ic_looks_black_48dp', 'ic_looks_one_black_48dp', 'ic_looks_two_black_48dp', 'ic_loupe_black_48dp', 'ic_monochrome_photos_black_48dp', 'ic_movie_creation_black_48dp', 'ic_movie_filter_black_48dp', 'ic_music_note_black_48dp', 'ic_nature_black_48dp', 'ic_nature_people_black_48dp', 'ic_navigate_before_black_48dp', 'ic_navigate_next_black_48dp', 'ic_palette_black_48dp', 'ic_panorama_black_48dp', 'ic_panorama_fish_eye_black_48dp', 'ic_panorama_horizontal_black_48dp', 'ic_panorama_vertical_black_48dp', 'ic_panorama_wide_angle_black_48dp', 'ic_photo_album_black_48dp', 'ic_photo_black_48dp', 'ic_photo_camera_black_48dp', 'ic_photo_filter_black_48dp', 'ic_photo_library_black_48dp', 'ic_photo_size_select_actual_black_48dp', 'ic_photo_size_select_large_black_48dp', 'ic_photo_size_select_small_black_48dp', 'ic_picture_as_pdf_black_48dp', 'ic_portrait_black_48dp', 'ic_remove_red_eye_black_48dp', 'ic_rotate_90_degrees_ccw_black_48dp', 'ic_rotate_left_black_48dp', 'ic_rotate_right_black_48dp', 'ic_slideshow_black_48dp', 'ic_straighten_black_48dp', 'ic_style_black_48dp', 'ic_switch_camera_black_48dp', 'ic_switch_video_black_48dp', 'ic_tag_faces_black_48dp', 'ic_texture_black_48dp', 'ic_timelapse_black_48dp', 'ic_timer_10_black_48dp', 'ic_timer_3_black_48dp', 'ic_timer_black_48dp', 'ic_timer_off_black_48dp', 'ic_tonality_black_48dp', 'ic_transform_black_48dp', 'ic_tune_black_48dp', 'ic_view_comfy_black_48dp', 'ic_view_compact_black_48dp', 'ic_vignette_black_48dp', 'ic_wb_auto_black_48dp', 'ic_wb_cloudy_black_48dp', 'ic_wb_incandescent_black_48dp', 'ic_wb_iridescent_black_48dp', 'ic_wb_sunny_black_48dp', 'ic_add_location_black_48dp', 'ic_beenhere_black_48dp', 'ic_directions_bike_black_48dp', 'ic_directions_black_48dp', 'ic_directions_boat_black_48dp', 'ic_directions_bus_black_48dp', 'ic_directions_car_black_48dp', 'ic_directions_railway_black_48dp', 'ic_directions_run_black_48dp', 'ic_directions_subway_black_48dp', 'ic_directions_transit_black_48dp', 'ic_directions_walk_black_48dp', 'ic_edit_location_black_48dp', 'ic_ev_station_black_48dp', 'ic_flight_black_48dp', 'ic_hotel_black_48dp', 'ic_layers_black_48dp', 'ic_layers_clear_black_48dp', 'ic_local_activity_black_48dp', 'ic_local_airport_black_48dp', 'ic_local_atm_black_48dp', 'ic_local_bar_black_48dp', 'ic_local_cafe_black_48dp', 'ic_local_car_wash_black_48dp', 'ic_local_convenience_store_black_48dp', 'ic_local_dining_black_48dp', 'ic_local_drink_black_48dp', 'ic_local_florist_black_48dp', 'ic_local_gas_station_black_48dp', 'ic_local_grocery_store_black_48dp', 'ic_local_hospital_black_48dp', 'ic_local_hotel_black_48dp', 'ic_local_laundry_service_black_48dp', 'ic_local_library_black_48dp', 'ic_local_mall_black_48dp', 'ic_local_movies_black_48dp', 'ic_local_offer_black_48dp', 'ic_local_parking_black_48dp', 'ic_local_pharmacy_black_48dp', 'ic_local_phone_black_48dp', 'ic_local_pizza_black_48dp', 'ic_local_play_black_48dp', 'ic_local_post_office_black_48dp', 'ic_local_printshop_black_48dp', 'ic_local_see_black_48dp', 'ic_local_shipping_black_48dp', 'ic_local_taxi_black_48dp', 'ic_map_black_48dp', 'ic_my_location_black_48dp', 'ic_navigation_black_48dp', 'ic_near_me_black_48dp', 'ic_person_pin_black_48dp', 'ic_person_pin_circle_black_48dp', 'ic_pin_drop_black_48dp', 'ic_place_black_48dp', 'ic_rate_review_black_48dp', 'ic_restaurant_black_48dp', 'ic_restaurant_menu_black_48dp', 'ic_satellite_black_48dp', 'ic_store_mall_directory_black_48dp', 'ic_streetview_black_48dp', 'ic_subway_black_48dp', 'ic_terrain_black_48dp', 'ic_traffic_black_48dp', 'ic_train_black_48dp', 'ic_tram_black_48dp', 'ic_transfer_within_a_station_black_48dp', 'ic_zoom_out_map_black_48dp', 'ic_apps_black_48dp', 'ic_arrow_back_black_48dp', 'ic_arrow_downward_black_48dp', 'ic_arrow_drop_down_black_48dp', 'ic_arrow_drop_down_circle_black_48dp', 'ic_arrow_drop_up_black_48dp', 'ic_arrow_forward_black_48dp', 'ic_arrow_upward_black_48dp', 'ic_cancel_black_48dp', 'ic_check_black_48dp', 'ic_chevron_left_black_48dp', 'ic_chevron_right_black_48dp', 'ic_close_black_48dp', 'ic_expand_less_black_48dp', 'ic_expand_more_black_48dp', 'ic_first_page_black_48dp', 'ic_fullscreen_black_48dp', 'ic_fullscreen_exit_black_48dp', 'ic_last_page_black_48dp', 'ic_menu_black_48dp', 'ic_more_horiz_black_48dp', 'ic_more_vert_black_48dp', 'ic_refresh_black_48dp', 'ic_subdirectory_arrow_left_black_48dp', 'ic_subdirectory_arrow_right_black_48dp', 'ic_unfold_less_black_48dp', 'ic_unfold_more_black_48dp', 'ic_adb_black_48dp', 'ic_airline_seat_flat_angled_black_48dp', 'ic_airline_seat_flat_black_48dp', 'ic_airline_seat_individual_suite_black_48dp', 'ic_airline_seat_legroom_extra_black_48dp', 'ic_airline_seat_legroom_normal_black_48dp', 'ic_airline_seat_legroom_reduced_black_48dp', 'ic_airline_seat_recline_extra_black_48dp', 'ic_airline_seat_recline_normal_black_48dp', 'ic_bluetooth_audio_black_48dp', 'ic_confirmation_number_black_48dp', 'ic_disc_full_black_48dp', 'ic_do_not_disturb_alt_black_48dp', 'ic_do_not_disturb_black_48dp', 'ic_do_not_disturb_off_black_48dp', 'ic_do_not_disturb_on_black_48dp', 'ic_drive_eta_black_48dp', 'ic_enhanced_encryption_black_48dp', 'ic_event_available_black_48dp', 'ic_event_busy_black_48dp', 'ic_event_note_black_48dp', 'ic_folder_special_black_48dp', 'ic_live_tv_black_48dp', 'ic_mms_black_48dp', 'ic_more_black_48dp', 'ic_network_check_black_48dp', 'ic_network_locked_black_48dp', 'ic_no_encryption_black_48dp', 'ic_ondemand_video_black_48dp', 'ic_personal_video_black_48dp', 'ic_phone_bluetooth_speaker_black_48dp', 'ic_phone_forwarded_black_48dp', 'ic_phone_in_talk_black_48dp', 'ic_phone_locked_black_48dp', 'ic_phone_missed_black_48dp', 'ic_phone_paused_black_48dp', 'ic_power_black_48dp', 'ic_priority_high_black_48dp', 'ic_rv_hookup_black_48dp', 'ic_sd_card_black_48dp', 'ic_sim_card_alert_black_48dp', 'ic_sms_black_48dp', 'ic_sms_failed_black_48dp', 'ic_sync_black_48dp', 'ic_sync_disabled_black_48dp', 'ic_sync_problem_black_48dp', 'ic_system_update_black_48dp', 'ic_tap_and_play_black_48dp', 'ic_time_to_leave_black_48dp', 'ic_vibration_black_48dp', 'ic_voice_chat_black_48dp', 'ic_vpn_lock_black_48dp', 'ic_wc_black_48dp', 'ic_wifi_black_48dp', 'ic_ac_unit_black_48dp', 'ic_airport_shuttle_black_48dp', 'ic_all_inclusive_black_48dp', 'ic_beach_access_black_48dp', 'ic_business_center_black_48dp', 'ic_casino_black_48dp', 'ic_child_care_black_48dp', 'ic_child_friendly_black_48dp', 'ic_fitness_center_black_48dp', 'ic_free_breakfast_black_48dp', 'ic_golf_course_black_48dp', 'ic_hot_tub_black_48dp', 'ic_kitchen_black_48dp', 'ic_pool_black_48dp', 'ic_room_service_black_48dp', 'ic_smoke_free_black_48dp', 'ic_smoking_rooms_black_48dp', 'ic_spa_black_48dp', 'ic_cake_black_48dp', 'ic_domain_black_48dp', 'ic_group_add_black_48dp', 'ic_group_black_48dp', 'ic_location_city_black_48dp', 'ic_mood_bad_black_48dp', 'ic_mood_black_48dp', 'ic_notifications_active_black_48dp', 'ic_notifications_black_48dp', 'ic_notifications_none_black_48dp', 'ic_notifications_off_black_48dp', 'ic_notifications_paused_black_48dp', 'ic_pages_black_48dp', 'ic_party_mode_black_48dp', 'ic_people_black_48dp', 'ic_people_outline_black_48dp', 'ic_person_add_black_48dp', 'ic_person_black_48dp', 'ic_person_outline_black_48dp', 'ic_plus_one_black_48dp', 'ic_poll_black_48dp', 'ic_public_black_48dp', 'ic_school_black_48dp', 'ic_sentiment_dissatisfied_black_48dp', 'ic_sentiment_neutral_black_48dp', 'ic_sentiment_satisfied_black_48dp', 'ic_sentiment_very_dissatisfied_black_48dp', 'ic_sentiment_very_satisfied_black_48dp', 'ic_share_black_48dp', 'ic_whatshot_black_48dp', 'ic_star_black_48dp', 'ic_star_border_black_48dp', 'ic_star_half_black_48dp'
        ];
    return icons[random(0,icons.length-1)];
}


/**
 * 设置渐变色--蓝色 红色 白色
 * @param {*} view
 * @param {*} color_name
 * @param {*} direction1
 * @param {*} direction2
 */
common.setGradual = function(view,color_name,direction1,direction2){
    importClass(android.graphics.Color);
    importClass(android.graphics.drawable.GradientDrawable);
    let color_arr = [];
    if(Object.prototype.toString.call(color_name) === '[object Array]'){
        color_arr = color_name;
    }else{
        switch (color_name) {
            case "蓝色":
                color_arr = ["#38d6f5","#a3e8f5","#c4f2f3","#8df7e2","#a9f9f4","#d4f2ec"];
                break;
            case "红色":
                color_arr = ["#F12713","#F74747","#D64542","#D34D58","#F04936","#D71F17"];
                break;
            case "白色":
                color_arr = ["#F0F8FF","#F0F8FF","#eaf0f5","#fcfcfd","#f7f7f8","#e9ebec"];
                break;
            default:
                color_arr = ["#38d6f5","#a3e8f5","#c4f2f3","#8df7e2","#a9f9f4","#d4f2ec"];//默认蓝色
                break;
        }
    }
    let colorArr = util.java.array("int", color_arr.length);
    color_arr.forEach(function(item,index) {
        colorArr[index] = colors.parseColor(item);
    });

    let gradientDrawable = new GradientDrawable();
    gradientDrawable.setShape(GradientDrawable.RECTANGLE);
    gradientDrawable.setColors(colorArr); //添加颜色组
    gradientDrawable.setGradientType(GradientDrawable.LINEAR_GRADIENT); //设置线性渐变
    //设置渐变方向
    switch (direction1) {
        case "TOP_BOTTOM":
            //从顶部到底部绘制渐变
            gradientDrawable.setOrientation(GradientDrawable.Orientation.TOP_BOTTOM);
            break;
        case "TR_BL":
            //绘制从右上角到左下角的渐变
            gradientDrawable.setOrientation(GradientDrawable.Orientation.TR_BL);
            break;
        case "RIGHT_LEFT":
            //从右到左绘制渐变
            gradientDrawable.setOrientation(GradientDrawable.Orientation.RIGHT_LEFT);
            break;
        case "BR_TL":
            //从右下角到左上角绘制渐变
            gradientDrawable.setOrientation(GradientDrawable.Orientation.BR_TL);
            break;
        case "BOTTOM_TOP":
            //从底部到顶部绘制渐变
            gradientDrawable.setOrientation(GradientDrawable.Orientation.BOTTOM_TOP);
            break;
        case "BL_TR":
            //从左下角到右上角绘制渐变
            gradientDrawable.setOrientation(GradientDrawable.Orientation.BL_TR);
            break;
        case "LEFT_RIGHT":
            //从左到右绘制渐变
            gradientDrawable.setOrientation(GradientDrawable.Orientation.LEFT_RIGHT);
            break;
        case "TL_BR":
            //绘制从左上角到右下角的渐变
            gradientDrawable.setOrientation(GradientDrawable.Orientation.TL_BR);
            break;
        default:
            gradientDrawable.setOrientation(GradientDrawable.Orientation.TOP_BOTTOM);
            break;
    }
    gradientDrawable.setSize(50, 50);
    view.setBackground(gradientDrawable);

    if(direction2){
        let gradientDrawable2 = new GradientDrawable();
        gradientDrawable2.setShape(gradientDrawable2.RECTANGLE);
        gradientDrawable2.setColors(colorArr); //添加颜色组
        //设置线性渐变
        switch (direction2) {
            case "TOP_BOTTOM":
                //从顶部到底部绘制渐变
                gradientDrawable.setOrientation(GradientDrawable.Orientation.TOP_BOTTOM);
                break;
            case "TR_BL":
                //绘制从右上角到左下角的渐变
                gradientDrawable.setOrientation(GradientDrawable.Orientation.TR_BL);
                break;
            case "RIGHT_LEFT":
                //从右到左绘制渐变
                gradientDrawable.setOrientation(GradientDrawable.Orientation.RIGHT_LEFT);
                break;
            case "BR_TL":
                //从右下角到左上角绘制渐变
                gradientDrawable.setOrientation(GradientDrawable.Orientation.BR_TL);
                break;
            case "BOTTOM_TOP":
                //从底部到顶部绘制渐变
                gradientDrawable.setOrientation(GradientDrawable.Orientation.BOTTOM_TOP);
                break;
            case "BL_TR":
                //从左下角到右上角绘制渐变
                gradientDrawable.setOrientation(GradientDrawable.Orientation.BL_TR);
                break;
            case "LEFT_RIGHT":
                //从左到右绘制渐变
                gradientDrawable.setOrientation(GradientDrawable.Orientation.LEFT_RIGHT);
                break;
            case "TL_BR":
                //绘制从左上角到右下角的渐变
                gradientDrawable.setOrientation(GradientDrawable.Orientation.TL_BR);
                break;
            default:
                gradientDrawable.setOrientation(GradientDrawable.Orientation.TOP_BOTTOM);
                break;
        }
        gradientDrawable2.setSize(50, 50);
        view.setBackground(gradientDrawable2);
    }
    //     /**
    //  *
    //  */
    // TOP_BOTTOM,从顶部到底部绘制渐变
    // /**
    //  *
    //  */
    // TR_BL,绘制从右上角到左下角的渐变
    // /**
    //  *
    //  */
    // RIGHT_LEFT,从右到左绘制渐变
    // /**
    //  *
    //  */
    // BR_TL,从右下角到左上角绘制渐变
    // /**
    //  *
    //  */
    // BOTTOM_TOP,从底部到顶部绘制渐变
    // /**
    //  *
    //  */
    // BL_TR,从左下角到右上角绘制渐变
    // /**
    //  *
    //  */
    // LEFT_RIGHT,从左到右绘制渐变
    // /**
    //  *
    //  */
    // TL_BR,绘制从左上角到右下角的渐变


}

/**
* 计数(绑定设备)
*/
common.getUnique = function(){
    try{
        let res_file='';
        let path = "/sdcard/numberaa.tff"
        if(files.createWithDirs(path)){
            files.write(path,0);
        }
        res_file =parseInt(files.read(path));
        files.write(path,res_file+1);
        return res_file;
    }catch(e){
        alert("请检查一下权限~");
        engines.all().forceStop();
    }
}

/**
 * 获取文件后缀名
 * @param {*} path
 */
common.getPathType = function(path){
    return path.substr(path.lastIndexOf(".")+1);
}

/**
 * 获取文件名
 * @param {*} path
 */
common.getFileName = function(path){
    return path.substring(path.lastIndexOf("/")+1,path.lastIndexOf("."));
}
/**
 * 获取文件路径
 * @param {*} path
 */
common.getFileRoad = function(path){
    return path.substring(0,path.lastIndexOf("/")+1);
}

/**
 * 删除数组arr的元素中id为id的元素
 * @param {*} arr
 * @param {*} id
 */
common.arrSplice = function(arr,id){

    return arr.splice(arr.findIndex(e => e.id === id), 1) // 将删除id等于id的选项

}

/**
 * 搜索数组[{}] icons中是否有keywords
 * @param {*} keywords
 * @param {*} icons
 */
common.search = function(keywords,icons){

    if((icons==null||icons.length==0)||(icons.length==1&&icons[0].length==0)){
        return false;
    }

    let result = [];
    for(let i = 0; i < icons.length; i++){
        let icon = icons[i]['text'];
        if(icon){
            if(icon.indexOf(keywords) >= 0){
                result.push(icons[i]);
            }
        }
    }
    return result;
}

common.uploadFile= function(url) {
    var res = http.get(url);
    if(res.statusCode != 200){
        toastLog("文件[" + url + "]下载失败");
    } else {
        //toastLog("文件[" + url + "]下载成功");
        return res.body.bytes();
    }
}

common.saveFile = function(saveDirPath, fileName, bytes) {
    if (!files.exists(saveDirPath)) {
        files.createWithDirs(saveDirPath);
    }
    files.writeBytes(saveDirPath + "/" + fileName, bytes);
}

/**
 * 判断一维、二维数组是否为空
 * @param {*} array
 */
common.arrIsEmpty = function(array){

    if (array == null || array == undefined) {
        return true;
        }

        if(Object.prototype.toString.call(array)==='[object object]' || Object.prototype.toString.call(array)==='[object Array]'){
            switch (JSON.stringify(array)) {
                case '[]':
                return true;
                break;
                case '{}':
                return true;
                break;
                case '[{}]':
                return true;
                break;
                case '{[]}':
                return true;
                break;
                default:
                break;
            }
        }else{
            switch (typeof array) {
                case 'undefined':

                    return true;
                case 'string':

                if (array.replace(/(^[ \t\n\r]*)|([ \t\n\r]*$)/g, '').length == 0){
                    return true;
                }
                break;
                case 'boolean':

                if (!array){
                    return true;
                }
                break;
                case 'number':

                if (0 === array || isNaN(array)){
                    return true;
                }
                break;
            }
        }

        return false;
}

/**
 * 关闭指定引擎
 * @param {*} arr Array ['main.js']
 */
common.stopEngines = function(arr){
    engines.all().forEach(function(item,index){
        let engine_name = item.source.toString();
        arr.forEach(function(item1,index1){
            if (engine_name.indexOf(item1) > -1) {
                item.forceStop();
                log("关闭:"+engine_name);
            }
        })
    });
}


/**
 * 获得指定脚本引擎的是否开启
 * @param {*} name
 * @returns
 */
common.getEngineStatus =function(name){
    let result;
    let all = engines.all();
    for (let index = 0; index < all.length; index++) {
        let item = all[index];
        let engine_name = item.source.toString();

        if (engine_name.indexOf(name) > -1) {
            result = item.destroyed;
            break;
        }
    }
    return result;
}



/**
 * 关闭除了str中的引擎
 * @param {*} str
 */
common.stopEnginesExtra = function(str){
    engines.all().forEach(function(item,index){
        let engine_name = item.source.toString();

            if (engine_name.indexOf(str) > -1) {
                item.forceStop();
                log("关闭:"+engine_name);
            }

    })

}



/**
 * 获取当前时间 格式 2020年1月20日16时37分
 * @param {*} timestamp string 1514736000000
 */
common.getNowTime = function(timestamp){
    let obj = timestamp?new Date(timestamp):new Date();
    return obj.toLocaleDateString()+obj.getHours()+'时'+obj.getMinutes()+'分'+obj.getSeconds()+'秒';
}

/**
 * 格式化秒
 * @param int  value 总秒数
 * @return string result 格式化后的字符串
 */
common.formatSeconds = function (value) {
    let theTime = parseInt(value);// 需要转换的时间秒
    let theTime1 = 0;// 分
    let theTime2 = 0;// 小时
    let theTime3 = 0;// 天
    if (theTime > 60) {
        theTime1 = parseInt(theTime / 60);
        theTime = parseInt(theTime % 60);
        if (theTime1 > 60) {
            theTime2 = parseInt(theTime1 / 60);
            theTime1 = parseInt(theTime1 % 60);
            if (theTime2 > 24) {
                //大于24小时
                theTime3 = parseInt(theTime2 / 24);
                theTime2 = parseInt(theTime2 % 24);
            }
        }
    }
    let result = '';
    if (theTime > 0) {
        result = "" + parseInt(theTime) + "秒";
    }
    if (theTime1 > 0) {
        result = "" + parseInt(theTime1) + "分" + result;
    }
    if (theTime2 > 0) {
        result = "" + parseInt(theTime2) + "小时" + result;
    }
    if (theTime3 > 0) {
        result = "" + parseInt(theTime3) + "天" + result;
    }
    return result;
}

/**
 * 文件下载
 * @param {*} link
 */
common.download = function(link) {
try{
    //下载链接拆分
    let strArray = link.split("/");
    let appName = strArray[strArray.length - 1];

    downloadDialog = dialogs.build({
        title: "正在下载……",
        cancelable: false,
        progress: {
            max: 100,
            showMinMax: true
        },
        autoDismiss: false
    }).show();
    threads.start(function () {
        importClass("java.io.FileOutputStream");
        importClass("java.io.IOException");
        importClass("java.io.InputStream");
        importClass("java.net.MalformedURLException");
        importClass("java.net.URL");
        importClass("java.net.URLConnection");
        importClass("java.util.ArrayList");
        let myPath = "/sdcard/" + appName;
        let url = new URL(link);
        let conn = url.openConnection(); //URLConnection
        let inStream = conn.getInputStream(); //InputStream
        let fs = new FileOutputStream(myPath); //FileOutputStream
        let connLength = conn.getContentLength(); //int
        let buffer = util.java.array('byte', 1024); //byte[]
        // buffer = new byte[1204]; //byte[]
        let byteSum = 0; //总共读取的文件大小
        let byteRead; //每次读取的byte数

        //开启一个线程下载文件
        threads.start(
            function () {
                while (1) {
                    let fileSize = byteSum
                    let percentage = fileSize / connLength * 100
                    downloadDialog.setProgress(percentage);
                    if (fileSize >= connLength) {
                        downloadDialog.dismiss();
                        alert("软件已下载到文件管理中，如未自动安装请手动安装");
                        app.startActivity({
                            data: "file://" + myPath,
                            type: "application/vnd.android.package-archive",
                            action: "VIEW",
                            flags: ["grant_read_uri_permission", "grant_write_uri_permission"]
                        })
                        break;
                    }
                    sleep(1000);
                }
            }

        );

        while ((byteRead = inStream.read(buffer)) != -1) {
            byteSum += byteRead;
            fs.write(buffer, 0, byteRead);
        }
        return true;
    });
}catch(e){
    toastLog("更新失败");
    return false;
}
}

/**
 * 获取cdk
 * @param {*} str
 */
common.getCdk = function(str){
    return str.substring(0,3)+str.substring(10,13)+str.substring(28,32);
}


/**
 * 生成唯一标识
 * @param {*} len  长度
 * @param {*} radix  基数
 */
common.uuid = function(len, radix) {
    let chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');
    let uuid = [], i;
    radix = radix || chars.length;

    if (len) {
        for (i = 0; i < len; i++) uuid[i] = chars[0 | Math.random()*radix];
    } else {

        uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
        uuid[14] = '4';

        for (i = 0; i < 36; i++) {
            if (!uuid[i]) {
                r = 0 | Math.random()*16;
                uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r];
            }
        }
    }
    return uuid.join('');
}

/**
 * 修改ui配置
 * @param {*} pp
 * @param {*} up
 */
common.updateConfig = function(pp,up){
    let file_read = files.read(pp);

    let file_readed = file_read.substring(file_read.indexOf("{"),file_read.indexOf("}")+1);

    let re_file = file_read.replace(file_readed,JSON.stringify(up));
    files.write(pp,re_file);
}

/**
 * 获取指定内容,返回对象
 * @param {*} pp
 */
common.getUpdateConfig = function(pp){
    let file_read = files.read(pp);

    let file_readed = file_read.substring(file_read.indexOf("{"),file_read.indexOf("}")+1);

    return JSON.parse(file_readed);
}

/**
 * 分享单个文件
 * @param {*} filepath
 */
common.share = function (filepath) {
    // let uri = new Uri.parse("/storage/emulated/0/建记/图片/img08.jpg");
    // let uri = new Uri.parse(filepath);
    let uri = app.getUriForFile(filepath);
    new SystemShareUtils().share(context, uri);
};



common.shareAll = function (filespath) {
    //不支持子文件夹中的文件。
    //let file= new File("/storage/emulated/0/超建记/文件夹");
    let file = new File(filespath);
    let list = file.listFiles();

    let uris = list.map(function(file) {
        return new Uri.fromFile(file);
    });
    new SystemShareUtils().shareList(context, uris);
};

function SystemShareUtils() {

    this.shareText = function(ctx, text) {
        sendIntent = new Intent();
        sendIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        sendIntent.setAction(Intent.ACTION_SEND);
        sendIntent.putExtra(Intent.EXTRA_TEXT, text);
        sendIntent.setType("text/plain");
        ctx.startActivity(Intent.createChooser(sendIntent, "分享至"));
    };

    this.share = function(ctx, uri) {
        sendIntent = new Intent(Intent.ACTION_SEND);
        sendIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_EXCLUDE_FROM_RECENTS);
        // sendIntent.setAction(Intent.ACTION_SEND);
        sendIntent.putExtra(Intent.EXTRA_STREAM,uri);
        sendIntent.setType("*/*");
        app.startActivity(Intent.createChooser(sendIntent, "分享至"));

    };

    this.shareList = function(ctx, uris) {
        sendIntent = new Intent();
        sendIntent.setAction(Intent.ACTION_SEND_MULTIPLE);
        sendIntent.putExtra(Intent.EXTRA_STREAM, uris);
        share.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        share.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
        sendIntent.setType("*/*");
        ctx.startActivity(Intent.createChooser(sendIntent, "分享至"));
    };
}


/**获取指定应用的版本号 */
common.getPackageVersion = function(packageName) {
    importPackage(android.content);
    let pckMan = context.getPackageManager();
    let packageInfo = pckMan.getPackageInfo(packageName, 0);
    return packageInfo.versionName;
}

/**
 * 定时器-标记定义
 */
common.TimerInfo = [];

/**
 * 定时器-标记赋值
 * @param {*} id
 */
common.TimeSign = function (id){
    common.TimerInfo[id] = Date.parse(new Date())/1000;
}

/**
 * 定时器-主程序
 * @param {*} id
 * @param {*} diff
 */
common.Timer = function(id,diff){
    let t1 =Date.parse(new Date())/1000;

    if(t1-common.TimerInfo[id] >= diff){
        return true;
    }else{
        return false;
    }
}

function simpPYStr (){
    return '暂无场景抖音快手视频号小红书抖音火山版快手极速版阅读赚今日头条今日头条极速版西瓜视频微视';
}
function ftPYStr (){
    return '暂无场景蚪因筷售世頻号小鸿梳蚪因伙山版筷售吉素版粤读赚金日投条金日投条吉素版夕瓜世頻威世';
}
function qqPYStr ()
{
    return '暂无场景阧洇㭈㖟嗜貧蠔小苰漱阧洇鈥钐版㭈㖟辑泝版鈅鍍赚琎鈤頭宨琎鈤頭宨辑泝版汐絓释貧薇饰';
}
function traditionalized(cc){
    var str='';
    for(var i=0;i<cc.length;i++){
        if(simpPYStr().indexOf(cc.charAt(i))!=-1)
            str+=ftPYStr().charAt(simpPYStr().indexOf(cc.charAt(i)));
        else if(qqPYStr().indexOf(cc.charAt(i))!=-1)
            str+=ftPYStr().charAt(qqPYStr().indexOf(cc.charAt(i)));
        else
            str+=cc.charAt(i);
    }
    return str;
}
function simplized(cc){
    var str='';
    for(var i=0;i<cc.length;i++){
        if(ftPYStr().indexOf(cc.charAt(i))!=-1)
            str+=simpPYStr().charAt(ftPYStr().indexOf(cc.charAt(i)));
        else if(qqPYStr().indexOf(cc.charAt(i))!=-1)
            str+=simpPYStr().charAt(qqPYStr().indexOf(cc.charAt(i)));
        else
            str+=cc.charAt(i);
    }
    return str;
}
function qqlized(cc){
    var str='';
    for(var i=0;i<cc.length;i++){
        if(ftPYStr().indexOf(cc.charAt(i))!=-1)
            str+=qqPYStr().charAt(ftPYStr().indexOf(cc.charAt(i)));
        else if(simpPYStr().indexOf(cc.charAt(i))!=-1)
            str+=qqPYStr().charAt(simpPYStr().indexOf(cc.charAt(i)));
        else
            str+=cc.charAt(i);
    }
    return str;
}



common.convert = function(nOption,value){
    if(nOption==0)//转换成简体
        return simplized(value);
    if(nOption==1)
        return traditionalized(value);//转换成繁体
    if(nOption==2)
        return qqlized(value);//转换成qq个性繁体
}


/***************************************************** */

/**
 * 对比节点信息(有id)
 * @param {*} uiObj
 * @param {*} it
 */
common.checkRes = function(uiObj,it) {
    if(uiObj){
        let arr2 = [];
        let i = 0;
        let class1 = JSON.stringify(it['className']);
        let class2 = JSON.stringify(uiObj.className());
        let text1 = JSON.stringify(it['text']);
        let text2 = JSON.stringify(uiObj.text());
        let depth1 = JSON.stringify(it['depth']);
        let depth2 = JSON.stringify(uiObj.depth());
        let hashCode1 = JSON.stringify(it['hashCode']);
        let hashCode2 = JSON.stringify(uiObj.hashCode());
        let desc1 = JSON.stringify(it['desc']);
        let desc2 = JSON.stringify(uiObj.desc());
        let getChildCount1 = JSON.stringify(it['getChildCount']);
        let getChildCount2 = JSON.stringify(uiObj.getChildCount());
        let children1 = JSON.stringify(it['children']);
        let children2 = JSON.stringify(uiObj.children());
        let getActionList1 = JSON.stringify(it['getActionList']);
        let getActionList2 = JSON.stringify(uiObj.getActionList());
        let getWindow1 = JSON.stringify(it['getWindow']);
        let getWindow2 = JSON.stringify(uiObj.getWindow());
        let clickable1 = JSON.stringify(it['clickable']);
        let clickable2 = JSON.stringify(uiObj.clickable());
        // let indexInParent1 = JSON.stringify(uiObj.indexInParent());
        // let indexInParent2 = JSON.stringify(uiObj.indexInParent());
        for (let index = 0; index < show_ary.length; index++) {
        // show_ary.forEach(function(item,index){
            let item = show_ary[index];
            let uiobj_item = eval('uiObj.' + item + '()');

            let condition_zero = (function(){if(!!text1 && !!text2){if(text1 == text2 && desc1 == desc2){return true;}}return false;}());
            //条件一：text相同
            let condition_one = (condition_zero && children1 == children2);

            //条件一：hashCode相同strict条件
            let condition_two = (hashCode1 == hashCode2 && getWindow1 == getWindow2 && children1 == children2);

            //text、desc均不同找特征值
            let condition_three = (depth1 == depth2 && class1 == class2 && getChildCount1 == getChildCount2 && getActionList1 == getActionList2);

            if(it['id'] == uiObj.id() && uiObj.visibleToUser()){

                //id不为空
                if(it['id']){
                    if(condition_zero){
                        log("找到了1zero");
                        return true;
                    }
                    if(condition_two){
                        log("找到了1two");
                        return true;
                    }
                    if(condition_three){
                        log("找到了1three");
                        return true;
                    }
                }

            }
        }

        return false;
    }
}



common.checkResNoId = function (uiObj,it) {
    if(uiObj){
        let arr2 = [];
        let i = 0;
        let class1 = JSON.stringify(it["className"]);
        let class2 = JSON.stringify(uiObj.className());
        let text1 = JSON.stringify(it["text"]);
        let text2 = JSON.stringify(uiObj.text());
        let depth1 = JSON.stringify(it["depth"]);
        let depth2 = JSON.stringify(uiObj.depth());
        let hashCode1 = JSON.stringify(it["hashCode"]);
        let hashCode2 = JSON.stringify(uiObj.hashCode());
        let desc1 = JSON.stringify(it["desc"]);
        let desc2 = JSON.stringify(uiObj.desc());
        let getChildCount1 = JSON.stringify(it["getChildCount"]);
        let getChildCount2 = JSON.stringify(uiObj.getChildCount());
        let children1 = JSON.stringify(it["children"]);
        let children2 = JSON.stringify(uiObj.children());
        let getActionList1 = JSON.stringify(it["getActionList"]);
        let getActionList2 = JSON.stringify(uiObj.getActionList());
        let getWindow1 = JSON.stringify(it["getWindow"]);
        let getWindow2 = JSON.stringify(uiObj.getWindow());
        let clickable1 = JSON.stringify(it["clickable"]);
        let clickable2 = JSON.stringify(uiObj.clickable());

        for (let index = 0; index < show_ary.length; index++) {

            let item = show_ary[index];
            let uiobj_item = eval("uiObj." + item + "()");




            let condition_zero = (function(){if(!!text1 && !!text2){if(text1 == text2 && desc1 == desc2){return true;}}return false;}());

            let condition_one = (condition_zero && children1 == children2);


            let condition_two = (hashCode1 == hashCode2 && getWindow1 == getWindow2 && children1 == children2);

            let condition_three = (depth1 == depth2 && class1 == class2 && children1 == children2 && getChildCount1 == getChildCount2 && getActionList1 == getActionList2);

            let condition_four = (function(){if((text1==text2) || (text1 == desc2) || (desc1==text2) || (desc2==desc1)){return true}return false}());


                if(condition_zero){
                    if(condition_two){

                        log("找到了2two");
                        return true;
                    }
                    if(condition_three){
                        log(text1 == text2);
                        log(desc1 == desc2);
                        log("找到了2three");
                        return true;
                    }
                    return true;
                }




            if(JSON.stringify(it[item]) == JSON.stringify(uiobj_item)){
                i++;
            }
        }

        if (i >= 13) {
            log("匹配成功"+i);

            return true;
        }
            log("匹配失败"+i);

        return false;
    }
}


/**
 * 获取某坐标点的控件信息(最底层);
 * @param {*} x
 * @param {*} y
 */
common.getRes = function (x,y) {
    try{
        //过滤对象
        let uiObj_ary = find().filter(function (uiObj) {

                let rect = uiObj.bounds();
                return rect.contains(x, y);

        }).sort(function (A, B) {
            AR = A.bounds();
            BR = B.bounds();
            return BR.width() * BR.height() - AR.width() * AR.height();
        });


        let resArr = {};
        for (let i = 0; i < uiObj_ary.length; i++) {

            let uiObj = uiObj_ary[i];

            if (uiObj) {
                resArr.packageName = uiObj.packageName();
                if (i == uiObj_ary.length - 1) {

                    for (let i = 0; i < show_ary.length; i++) {
                        let show_ary_item = show_ary[i];
                        // log(show_ary[i] + ": " + uiObj[show_ary[i]]());
                        resArr[show_ary_item] = uiObj[show_ary[i]]();
                    };

                };

            };
        };
        return resArr;
    }catch(e){
        log("1160:"+e);
        return [];
    }
}



/**************************************************************************************************************通用点击方法************************************************************************************************************************************ */
/**
 * 节点点击
 * @param {*} nodeinfo 节点id，或desc信息。
 * @param {*} nodetype 节点类型：d，t，i，tc，dc。
 * @param {*} clicktype 点击类型：1->节点点击，2->绑定坐标点击。
 * @param {*} sleeptime 数组，一个元素固定时间，两个元素随机区间。单位毫秒
 * @returns 点击是否成功。
 */
 common.node_click = function(nodeinfo,nodetype,clicktype,sleeptime){
    let node;
    switch (nodetype) {
        case 'tc':
            node = textContains(nodeinfo).visibleToUser().findOnce();
            break;
        case 'dc':
            node = descContains(nodeinfo).visibleToUser().findOnce();
            break;
        case 't':
            node = text(nodeinfo).visibleToUser().findOnce();
            break;
        case 'd':
            node = desc(nodeinfo).visibleToUser().findOnce();
            break;
        case 'i':
            node = id(nodeinfo).visibleToUser().findOnce();
            break;
        default:
            node = id(nodeinfo).visibleToUser().findOnce();
            break;
    }
    if(node){
        if(clicktype === 1){
            node.click();
        }else{
            click(node.bounds().centerX(),node.bounds().centerY());
        }
        if(sleeptime.length === 1){
            sleep(sleeptime[0]);
        }else if(sleeptime.length === 2){
            sleep(random(sleeptime[0],sleeptime[1]));
        }
        return true;
    }else{
        return false;
    }
};

/**
 * 对集合元素点击的方法
 * @param {*} nodeinfo 节点id
 * @param {*} sleeptime 数组
 */
common.item_click = function(nodeinfo,sleeptime){
    let node;
    node = id(nodeinfo).visibleToUser().find();
    if(node){
        node.forEach(element => {
            element.click();
            if(sleeptime.length === 1){
                sleep(sleeptime[0]);
            }else if(sleeptime.length === 2){
                sleep(random(sleeptime[0],sleeptime[1]));
            }
        });
    }
}

// 其他通用方法

/**
 * 检测到节点后向下滑动 直播间跳过
 * @param {*} nodeinfo 节点信息
 * @param {*} nodetype 节点类型
 * @param {*} sleeptime 数组
 * @returns
 */
common.detect_slide = function(nodeinfo,nodetype,sleeptime){
    let node;
    switch (nodetype) {
        case 'tc':
            node = textContains(nodeinfo).visibleToUser().findOnce();
            break;
        case 'dc':
            node = descContains(nodeinfo).visibleToUser().findOnce();
            break;
        case 't':
            node = text(nodeinfo).visibleToUser().findOnce();
            break;
        case 'd':
            node = desc(nodeinfo).visibleToUser().findOnce();
            break;
        case 'i':
            node = id(nodeinfo).visibleToUser().findOnce();
            break;
        default:
            node = id(nodeinfo).visibleToUser().findOnce();
            break;
    }
    if(node){
        swipe(device.width*0.75,device.height*0.7,device.width*0.8,device.height*0.1,300);
        if(sleeptime.length === 1){
            sleep(sleeptime[0]);
        }else if(sleeptime.length === 2){
            sleep(random(sleeptime[0],sleeptime[1]));
        }
        return true;
    }else{
        return false;
    }
}

/**
 * 概率处理
 * @param {*} c 字符串 带百分号
 * @returns
 */
common.chance = function(c){
    switch (c) {
        case '100%':
            return true;
        case '0%':
            return false;
        default:
            return (random(1, 100) <= parseInt(c.replace('%', '')));
    }
}

/**
 * 检查应用版本
 * @param {*} pkginfo 应用包名
 * @param {*} sup_version 支持版本号
 */
common.check_appversion = function(pkginfo,sup_version){
    let app_version;
    try {
        let pckMan = context.getPackageManager();
        let packageInfo = pckMan.getPackageInfo(pkginfo, 0);
        app_version = packageInfo.versionName;
    } catch (e) {
        app_version = '0.0.0';
    }
    if (app_version != sup_version) {
        dialogs.build({
            title: "提示",
            content: "当前应用版本" + app_version + "不正确",
            positive: "确认",
            cancelable: false,
        }).on("positive", function () {
            toast("程序停止");
            engines.stopAll();
            exit();
        }).show();
    }
}

/**
 * 循环返回，页面定位
 * @param {*} nodeinfo 节点信息
 * @param {*} nodetype 节点类型
 * @param {*} positiontype 定位类型，1->节点存在执行，2->节点不存在执行。
 * @param {*} sleeptime 数组
 */
common.loop_back = function(nodeinfo,nodetype,positiontype,sleeptime){
    let node;
    let result;
    while(true){
        switch (nodetype) {
            case 'tc':
                node = textContains(nodeinfo).visibleToUser().findOnce();
                break;
            case 'dc':
                node = descContains(nodeinfo).visibleToUser().findOnce();
                break;
            case 't':
                node = text(nodeinfo).visibleToUser().findOnce();
                break;
            case 'd':
                node = desc(nodeinfo).visibleToUser().findOnce();
                break;
            case 'i':
                node = id(nodeinfo).visibleToUser().findOnce();
                break;
            default:
                node = id(nodeinfo).visibleToUser().findOnce();
                break;
        }

        if(positiontype === 1){
            result = node;
        }else{
            result = !node;
        }

        if(result){
            back();
        }else{
            break;
        }

        if(sleeptime.length === 1){
            sleep(sleeptime[0]);
        }else if(sleeptime.length === 2){
            sleep(random(sleeptime[0],sleeptime[1]));
        }
    }

}

/*
通过节点高度滑动
@ nodeinfo    节点信息
@ nodetype    节点类型
@ sleeptime    休眠时间
@ num          次数
*/
common.bounds_slide = function (nodeinfo, nodetype, sleeptime, num) {
    let node;
    switch (nodetype) {
        case 'id':
            node = id(nodeinfo).visibleToUser().findOnce();
            break;
        case 'text':
            node = text(nodeinfo).visibleToUser().findOnce();
            break;
        case 'textContains':
            node = textContains(nodeinfo).visibleToUser().findOnce();
            break;
        case 'desc':
            node = desc(nodeinfo).visibleToUser().findOnce();
            break;
        case 'descContains':
            node = descContains(nodeinfo).visibleToUser().findOnce();
            break;
        default:
            return false;
    }

    if (node) {
        let hd_h = node.bounds();
        let x1 = 300;
        let y1 = hd_h.bottom;
        let x2 = 300;
        let y2 = hd_h.top;
        for (let index = 0; index < num; index++) {
            gesture(1500, [x1, y1 - 250], [x2, y2]);
            if (sleeptime.length == 1) {
                sleep(sleeptime[0]);
            } else {
                sleep(random(sleeptime[0], sleeptime[1]));
            }
        }
    } else {
        return false;
    }
}

/*
全屏滑动
*/
common.fullscreen_slide = function () {
    let W = device.width;
    let H = device.height;
    gesture(300, [W * 0.8, H * 0.7], [W * 0.85, 0]);
}

/*
获取该控件的desc text内容
@ nodeinfo    节点信息
@ nodetype    获取内容类型
@ sleeptime   休眠时间
*/
common.present_content = function (nodeinfo, nodetype, sleeptime) {
    let text;
    let desc;
    switch (nodetype) {
        case 'text':
            text = id(nodeinfo).visibleToUser().findOnce();
            break;
        case 'desc':
            desc = id(nodeinfo).visibleToUser().findOnce();
            break;
        default:
            return false;
    }

    if (text) {
        text = text.text();
        if (sleeptime.length == 1) {
            sleep(sleeptime[0]);
        } else {
            sleep(random(sleeptime[0], sleeptime[1]));
        }
    } else if (desc) {
        desc = desc.desc();
        if (sleeptime.length == 1) {
            sleep(sleeptime[0]);
        } else {
            sleep(random(sleeptime[0], sleeptime[1]));
        }
    } else {
        return false;
    }
}


/**
 轮询任务
**/
common.run_task = function() {
    let data = JSON.parse(engines.myEngine().execArgv.data);
    alert(JSON.stringify(data))
    let data_now = [];
    if (data.length > 0) {
        data.forEach(function (item, index) {
            let files_ = item.files;
            files_.forEach(function (v, k) {
                data_now.push(v);
            });
        });
        data = data_now ? data_now : {
                                    task_id: null
                                };
        data = data_now;
        let runTime = engines.myEngine().execArgv.runTime;
        let data__ = [];
        data.forEach(function (item, index) {
            let name_ = item.name;
            let url_ = item.url;
            let fileType = item.fileType;
            let run_time = item.runTime;
            if (url_) {
                url_ = url_;
                sleep(Math.random(0, 10) * 1000);
                let res = http.get(url_);
                if (res.statusCode == 200) {
                    res = res.body.string();
                    data__.push({
                        name: name_,
                        url: url_,
                        res: res,
                        run_time: run_time,
                        fileType: fileType,
                        extraParams: item.extraParams ? item.extraParams.toString() : '',
                        pollingInterval: item.pollingInterval ? item.pollingInterval.toString() : '3', //操作间隔
                        actionInterval: item.actionInterval ? item.actionInterval.toString() : '3' //动作间隔
                    });
                }
            }
        });
        runTime = runTime ? runTime : 1;//轮询次数
        log('任务轮询次数:' + runTime + '次' + typeof (runTime));
        common.TimeSign(10001);
        let ii = 0;
        while (true) {
                if (ii >= parseInt(runTime)) {
                    toastLog('任务运行完毕，任务结束');
                    engines.stopAll();
                    sleep(2000);
                    break;
                }
                alert(JSON.stringify(data__))
                for (let index = 0; index < data__.length; index++) {
                    nodes = null;
                    let item = data__[index];
                    let name_ = item.name;
                    let url_ = item.url;
                    let res = item.res;
                    let run_time = item.run_time;
                    let fileType = item.fileType;
                    let extraParams = item.extraParams ? item.extraParams.toString() : '';
                    let pollingInterval = item.pollingInterval ? item.pollingInterval.toString() : '5';
                    let actionInterval = item.actionInterval? item.actionInterval.toString() : '5';

                    if (res) {
                        let Config = JSON.parse(res.substring(res.indexOf('Config = {')+9, res.indexOf('};') + 1));
                        let run_appName = Config.app_appName;
                        let run_appPkg = Config.app_appPkg;
                        let run_version = Config.app_version;
                        let now_app_version = common.getPackageVersion(run_appPkg);

                        toastLog('场景运行位置:' + run_appName);

                        if (now_app_version != run_version) {
                            alert('当前设备上的' + run_appName + '版本:' + now_app_version + '与所录制场景的版本' + run_version + '不符合!');

                            return;

                        }
                        try{
                            let nodes_api = http.post("http://47.93.61.133/api/getNodeVersion?time=' + Date.parse(new Date().getTime())",
                            {
                                packageName:Config.app_appPkg,
                                version:Config.app_version,
                                code:storage.getStr('code')
                            });
                            let nodes_data = JSON.parse(nodes_api.body.string());
                            if(nodes_data.code == 0){
                                try{
                                    nodes = JSON.parse(files.readme(nodes_data.data));
                                }catch(e){
                                    alert('授权信息错误，请检查软件版本');
                                    return;
                                }
                            }else{
                                alert('暂未适配该版本');
                                return;
                            }
                        }catch(e){
                            alert('网络错误')
                            return;
                        }

                        if (res.indexOf('//不开app啊啊') == -1) {
                            log('//不开app啊啊');
                            app.launch(run_appPkg);
                            sleep(1200);
                            app.launchApp(run_appName);
                            sleep(10000);
                        }
                        let task_script = res;

                        let data_ = {};
                        data_.run_time = run_time;
                        data_.extraParams = extraParams.toString();
                        data_.actionInterval = actionInterval.toString();
                        let pollingInterval_ = pollingInterval.toString().split('+');
                        if (pollingInterval_.length == 2) {
                            pollingInterval_ = random(parseInt(pollingInterval_[0].trim()), parseInt(pollingInterval_[1].trim()));
                        } else {
                            pollingInterval_ = pollingInterval_[0].trim();
                        }

                        engines.execScriptFile('./popcheck.js',{arguments:{config:{run_app:'com.ss.android.ugc.aweme'},workingDirectory:engines.myEngine().cwd()}});
                        let script_engine = engines.execScript('task', task_script + chance.toString() + checkRes.toString() + checkResNoId.toString(), {
                            arguments: {
                                config: {
                                    run_data: data_,
                                    common:common,
                                    nodes:nodes,
                                    currency:currency,
                                    process:process
                                }
                            },
                            loopTimes: run_time,
                            interval: pollingInterval * 1000
                        });

                        sleep(1100);
                        // if(fileType==2){
                        //     data__.splice(index, 1);
                        // }
                        if (script_engine) {
                            while (true) {
                                if (script_engine.getEngine().destroyed) {
                                    break;
                                }
                                sleep(3000);
                            }
                        }
                        common.stopEngines(['task', 'popcheck','runCollection']);
                        sleep(1100);
                    }

                }
                sleep(500);
                ii++;
            }
    }


}

common.backhome = function(){
    toastLog("返回桌面");
    for (let i = 0; i < 3; i++) {
        back();
        sleep(3000);
    }
    let kstc = text("退出").findOnce();
    if (kstc) {
        kstc.click();
    }
    for (let i = 0; i < 20; i++) {
        back();
        sleep(400);
    }
}
/**
 采集任务
**/
common.collect = function() {
    let task_data = JSON.parse(engines.myEngine().execArgv.task_data);
    let task_type = task_data.type_key;
    var task_url = '';
    switch (task_type) {
        case "industry":
            log("行业");
            task_url = 'https://dyver.oss-cn-beijing.aliyuncs.com/jgz/1%E6%89%AB%E6%8F%8F%E4%B8%93%E7%94%A8/gather197/%E8%A1%8C%E4%B8%9A%E9%87%87%E9%9B%86.js' + '?times=' + Date.parse(new Date().getTime());
            break;
        case "room":
            log("直播间");
            task_url = 'https://dyver.oss-cn-beijing.aliyuncs.com/jgz/%E7%9B%B4%E6%92%AD%E9%97%B4%E5%86%85%E9%87%87%E9%9B%86_2MMuyvfzzfzf.js' + '?times=' + Date.parse(new Date().getTime());
            break;
        case "user":
            log("用户");
            task_url = 'https://dyver.oss-cn-beijing.aliyuncs.com/jgz/1%E6%89%AB%E6%8F%8F%E4%B8%93%E7%94%A8/gather197/%E7%94%A8%E6%88%B7%E9%87%87%E9%9B%86.js' + '?times=' + Date.parse(new Date().getTime());
            break;
        case "production":
            log("作品");
            task_url = 'https://dyver.oss-cn-beijing.aliyuncs.com/jgz/1%E6%89%AB%E6%8F%8F%E4%B8%93%E7%94%A8/gather197/%E4%BD%9C%E5%93%81%E9%87%87%E9%9B%86.js' + '?times=' + Date.parse(new Date().getTime());
            break;
        case "position":
            log("智联招聘");
            task_url = 'https://dyver.oss-cn-beijing.aliyuncs.com/jgz/1%E6%89%AB%E6%8F%8F%E4%B8%93%E7%94%A8/%E7%AE%80%E5%8E%86%E9%87%87%E9%9B%86.js' + '?times=' + Date.parse(new Date().getTime());
            break;
        case "contacts":
            log("关注列表");
            task_url = 'https://dyver.oss-cn-beijing.aliyuncs.com/jgz/1%E6%89%AB%E6%8F%8F%E4%B8%93%E7%94%A8/gather197/%E5%85%B3%E6%B3%A8%E9%87%87%E9%9B%86.js' + '?times=' + Date.parse(new Date().getTime());
            break;
            case "phone":
                        log("行业手机号");
                        task_url = "https://dyver.oss-cn-beijing.aliyuncs.com/jgz/1%E6%89%AB%E6%8F%8F%E4%B8%93%E7%94%A8/gather197/%E8%A1%8C%E4%B8%9A%E6%89%8B%E6%9C%BA.js" + '?times=' + Date.parse(new Date().getTime());
                        break;
        default:
            return;
            break;
    }
        nodes = null;
        try{
            let nodes_api = http.post("http://47.93.61.133/api/getNodeVersion",
            {
                packageName:"com.ss.android.ugc.aweme",
                version:"21.9.0",
                code:storage.getStr("code")
            });
            let nodes_data = JSON.parse(nodes_api.body.string());
            if(nodes_data.code == 0){
                try{
                    nodes = JSON.parse(files.readme(nodes_data.data));
                }catch(e){
                     alert("授权信息错误，请检查软件版本");
                     return;
                 }

            }else{
                alert("暂未适配该版本");
                return;
            }
        }catch(e){
            alert("网络错误！"+e);
            return;
        }

    let task_script = http.get(task_url + '?times=' + Date.parse(new Date().getTime()));
    if (task_script.statusCode == 200) {
        task_script = task_script.body.string();
        engines.execScriptFile("popcheck.js",{arguments:{config:{run_app:"com.ss.android.ugc.aweme"},workingDirectory:engines.myEngine().cwd()}});
        task_data.common = this;
        task_data.nodes = nodes;
        task_data.currency = require('./currency.js');
        task_data.process = require('./process.js');
        let script_engine = engines.execScript("task", task_script, {
            arguments: {
                config: task_data
            }
        });
    } else {
        toastLog("网络错误");
    }
}


/**
 计时器
**/
common.jsq = function(){
    let require_data = engines.myEngine().execArgv;
    while(true){
        if (parseInt(getenv('RunCount')) >= require_data.loopTimes) {
            home();
            engines.stopAll();
            alert('运行次数达标!');
            break;
        }
        sleep(3000);
    }
}

common.runCollection = function(){
    let data = engines.myEngine().execArgv.data;
    for (let index = 0; index < data.length; index++) {
        let element = data[index];
        try{
            toastLog("即将开始运行"+element.appName+":"+element.name);
            if(element.fileType == 8){
                let now_app_version = common.getPackageVersion(element.appPkg);
                if(now_app_version!=element.appVersion){
                    alert("此"+element.appName+"版本"+ now_app_version + "与该场景所适配的版本" + element.appVersion + "不匹配，请下载对应的版本号重新运行");
                    return;
                }
            }else{
                let nodes_api = http.post(nodes_url+"api/getNodeVersion",
                {
                    packageName:element.appPkg,
                    version:element.appVersion,
                    code:storage.getStr("code")
                });
                let nodes_data = JSON.parse(nodes_api.body.string());
                if(nodes_data.code == 0){
                            try{
                                nodes = files.readme(nodes_data.data);
                                if(nodes.indexOf("{")>-1){
                                    nodes = JSON.parse(nodes);
                                }else{
                                    alert("授权信息错误，请检查软件版本");
                                    return;
                                }
                            }catch(e){
                                alert(e);
                                break;
                            }
                }else{
                    alert("暂未适配该"+element.appName+"版本");
                    return;
                }
            }

            launch(element.appPkg);
            sleep(3500);
            start_time = Date.parse(new Date())/1000;
            task_run_app = element.appPkg;
            task_run_text = element.name;
            let task_script = files.read(element.path);
            task_script_engine = engines.execScript("task", task_script + chance.toString() + checkRes.toString() + checkResNoId.toString(),
                {
                    arguments: {
                        config: {
                            local_run_data: true,
                            common:common,
                            nodes:nodes,
                            currency:currency,
                            process:process,
                        }
                    },
                    delay: 1000
                }
            );
            sleep(1500);

            if (task_script_engine) {
                while (true) {
                    if (task_script_engine.getEngine().destroyed) {

                        let end_time = Date.parse(new Date())/1000;
                        let run_time = end_time - start_time + 1;
                        setenv(task_run_app+'|'+task_run_text+'|时长', run_time);
                        task_run_app = null;
                        task_run_text = null;
                        start_time = 0;
                        setenv('RunCount', '');
                        setenv('RunMsg', '');
                        setenv('Running', false);
                        common.stopEngines(["task","jsq",'runCollection']);
                        break;
                    }
                    sleep(3000);
                }
            }
        }catch(e){
            start_time = 0;
            alert(getError(e));
            return;
        }
        sleep(1000);
    }
}

/**
 GG思密达
**/
common.gg = function(){
    com.douzhu.app.CaseMain.getInstance().gg();
}
module.exports = common;